package com.persagy.dmp.rwd.dic;

import cn.hutool.core.util.StrUtil;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.date.DateUtils;
import com.persagy.common.json.JacksonMapper;
import com.persagy.dmp.rwd.enums.ObjType;
import com.persagy.dmp.rwd.model.ClassDefModel;
import com.persagy.dmp.rwd.model.RwdeditRefTypeInfosModel;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringEscapeUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.junit.Test;

import java.io.*;
import java.util.*;

/**
 * 导入类型定义
 *
 * @author: yaoll
 * @date: 2020-11-30
 * @verison: 1.0
 */
@Slf4j
public class ImportKnowledgeForEdit {

    private String basepath = "D:\\users\\数据字典v3.1.11\\数据字典附表(20210701)";

    private String outPath = "D:/users/20210701/edit/ref-infos-" + DateUtils.format(new Date()) + ".dml.sql";

    private final static Integer CREATE_USER_ID=0;
    private final static Integer UPDATE_USER_ID=0;
    private final static ObjectMapper objectMapper = new ObjectMapper();

    @Test
    public void importClassData() throws Exception {

//        // 所有类型
        List<RwdeditRefTypeInfosModel> classes = new ArrayList<>();

        // 顶级类型
        // initBaseClass(classes);
        // 空间分区
        //initSpace(classes);
        // 专业\系统\设备\部件
//        initEquipment(classes,"major");
//        writeFuncSqlToFile(classes, "major");
//        classes.clear();
//        // 工具
//        initToolOrMaterial(classes,"tool","工具类");
//        writeFuncSqlToFile(classes, "tool");
//        classes.clear();
//        // 耗材
//        initToolOrMaterial(classes,"material","耗材类 ");
//        writeFuncSqlToFile(classes, "material");
//        classes.clear();
        // 省市区编号
//        initCityLocation(classes,"cityLocation","省市区编号");
//        writeFuncSqlToFile(classes, "cityLocation");
//        classes.clear();
//        // 气候分区
//        initClimaticDivision(classes,"climaticDivision","气候分区");
//        writeFuncSqlToFile(classes, "climaticDivision");
//        classes.clear();
//        // 信息点编码词汇
//        initFuncidCodeVocabulary(classes,"funcidCodeVocabulary","Sheet1");
//        writeFuncSqlToFile(classes, "funcidCodeVocabulary");
//        classes.clear();
//        // 地理分区
//        initGeographicalDivision(classes,"geographicalDivision","地理分区");
//        writeFuncSqlToFile(classes, "geographicalDivision");
//        classes.clear();
////        // 城市发展水平
//        initCityDevelopmentLevel(classes,"cityDevelopmentLevel","城市发展水平");
//        writeFuncSqlToFile(classes, "cityDevelopmentLevel");
//        classes.clear();
        // 天气状态
//        initWeatherConditions(classes,"weatherConditions","天气状态");
//        writeFuncSqlToFile(classes, "weatherConditions");
//        classes.clear();
//        // 空气风力等级
//        initAirWindRating(classes,"airWindRating","空气风力等级");
//        writeFuncSqlToFile(classes, "airWindRating");
//        classes.clear();
//        // 方向代码
//        initDirectionCode(classes,"directionCode","方向代码");
//        writeFuncSqlToFile(classes, "directionCode");
//        classes.clear();
//        // 抗震设防烈度
          initSeismicFortificationIntensity(classes,"seismicFortificationIntensity","抗震设防烈度");
          writeFuncSqlToFile(classes, "seismicFortificationIntensity");
//        classes.clear();
//        // 防尘等级
//        initDustproofLevel(classes,"dustproofLevel","防护等级");
//        writeFuncSqlToFile(classes, "dustproofLevel");
//        classes.clear();
//        // 防尘等级
//        initWaterproofLevel(classes,"waterproofLevel","防护等级");
//        writeFuncSqlToFile(classes, "waterproofLevel");
//        classes.clear();
//        // 污秽等级
//        initFilthLevel(classes,"filthLevel","污秽等级");
//        writeFuncSqlToFile(classes, "filthLevel");
//        classes.clear();
//        // 污染等级
//        initContaminatedLevel(classes,"contaminatedLevel","污染等级");
//        writeFuncSqlToFile(classes, "contaminatedLevel");
//        classes.clear();
//        // 职业分类
//        initOccupationalClassification(classes,"occupationalClassification","职业分类");
//        writeFuncSqlToFile(classes, "occupationalClassification");
//        classes.clear();
//        // 项目类型
//        initProjectType(classes,"projectType","项目类型");
//        writeFuncSqlToFile(classes, "projectType");
//        classes.clear();
//        // 建筑功能类型
//        initBuildFuncType(classes,"buildFuncType","建筑功能类型");
//        writeFuncSqlToFile(classes, "buildFuncType");
//        classes.clear();
//        // 空间功能类型
//        initSpaceFuncType(classes,"spaceFuncType","空间功能类型");
//        writeFuncSqlToFile(classes, "spaceFuncType");
//        classes.clear();
//        // 商业租赁业态类型
//        initCommercialLeasingType(classes,"commercialLeasingType","商业租赁业态类型");
//        writeFuncSqlToFile(classes, "commercialLeasingType");
//        classes.clear();
        // 通用面积树
      /*  initThreeLevelData(classes,"universalAreaTree","A0");
        writeFuncSqlToFile(classes, "universalAreaTree");
        classes.clear();
        // 商业综合体面积树
        initFourLevelData(classes,"businessSynthesisAreaTree","A1");
        writeFuncSqlToFile(classes, "businessSynthesisAreaTree");
        classes.clear();
        // 办公面积树
        initFourLevelData(classes,"officeSpaceTree","A2");
        writeFuncSqlToFile(classes, "officeSpaceTree");
        classes.clear();
        // 商场面积树
        initFourLevelData(classes,"shoppingMallAreaTree","A3");
        writeFuncSqlToFile(classes, "shoppingMallAreaTree");
        classes.clear();
        // 宾馆酒店面积树
        initFourLevelData(classes,"hotelAreaTree","A4");
        writeFuncSqlToFile(classes, "hotelAreaTree");
        classes.clear();
        // 医院面积树
        initFourLevelData(classes,"hospitalAreaTree","A5");
        writeFuncSqlToFile(classes, "hospitalAreaTree");
        classes.clear();
        // 学校面积树
        initFourLevelData(classes,"schoolAreaTree","A6");
        writeFuncSqlToFile(classes, "schoolAreaTree");
        classes.clear();
        // 通用分项树
        initSevenLevelData(classes,"generalSubTree","S0");
        writeFuncSqlToFile(classes, "generalSubTree");
        classes.clear();
        // 商业综合体分项树
        initFiveLevelData(classes,"businessSynthesisItemizedTree","S1");
        writeFuncSqlToFile(classes, "businessSynthesisItemizedTree");
        classes.clear();
        // 办公分项树
        initFiveLevelData(classes,"officeItemizedTree","S2");
        writeFuncSqlToFile(classes, "officeItemizedTree");
        classes.clear();
        // 商场分项树
        initFiveLevelData(classes,"shoppingMallItemTree","S3");
        writeFuncSqlToFile(classes, "shoppingMallItemTree");
        classes.clear();
        // 宾馆酒店分项树
        initFiveLevelData(classes,"hotelSubTree","S4");
        writeFuncSqlToFile(classes, "hotelSubTree");
        classes.clear();
        // 医院分项树
        initFiveLevelData(classes,"hospitalItemizedTree","S4");
        writeFuncSqlToFile(classes, "hospitalItemizedTree");*/
        classes.clear();
//        // 对象间关系
//        initObjectRelation(classes,"objectRelation","新版");
//        writeFuncSqlToFile(classes, "objectRelation");
//        classes.clear();
    }

    private void initObjectRelation(List<RwdeditRefTypeInfosModel> models,String refKey,String sheetName) throws IOException {
        String classFile = basepath + "/附表3-对象间关系.xlsx";
        FileInputStream inputStream = new FileInputStream(classFile);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);
        if (sheet == null) {
            return;
        }

        // 行号从0开始, 从第2行开始读数据
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        Set<String> equipmentCodes = new HashSet<>();
        int startRowNum = 1;
        int lastRowNum = sheet.getLastRowNum();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.firstLevelName = (String) ExcelUtils.parseCell(row.getCell(0), "string");// 关系两侧对象类别
            target.secondLevelName = (String) ExcelUtils.parseCell(row.getCell(1), "string");//图分类
            target.thirdLevelCode = (String) ExcelUtils.parseCell(row.getCell(2), "string");//图类型编码
            target.thirdLevelName = (String) ExcelUtils.parseCell(row.getCell(3), "string");//图类型名称
            target.fourthLevelCode = (String) ExcelUtils.parseCell(row.getCell(4), "string");//边类型编码
            target.fourthLevelName = (String) ExcelUtils.parseCell(row.getCell(5), "string");//边类型名称
            String edgeDirectivity= (String) ExcelUtils.parseCell(row.getCell(6), "string");//边方向性
            String propertyDirectivity = (String) ExcelUtils.parseCell(row.getCell(7), "string");//边属性
            String mainObjRelation = (String) ExcelUtils.parseCell(row.getCell(8), "string");//主要连接对象
            String remark = (String) ExcelUtils.parseCell(row.getCell(9), "string");//备注


            // 专业不为空
            if (target.firstLevelName != null) {
                cache.firstLevelName = target.firstLevelName;
                cache.secondLevelCode = null;
                cache.secondLevelName = null;
                cache.thirdLevelCode = null;
                cache.thirdLevelName = null;
                cache.fourthLevelCode = null;
                cache.fourthLevelName = null;
            } else {
                target.firstLevelName = cache.firstLevelName;
            }
            // 系统不为空
            if (target.secondLevelName != null) {
                cache.secondLevelName = target.secondLevelName;
                cache.thirdLevelCode = null;
                cache.thirdLevelName = null;
                cache.fourthLevelCode = null;
                cache.fourthLevelName = null;
            } else {
                target.secondLevelName = cache.secondLevelName;
            }
            // 系统不为空
            if (target.thirdLevelCode != null) {
                cache.thirdLevelCode = target.thirdLevelCode;
                cache.thirdLevelName = target.thirdLevelName;
                cache.fourthLevelCode = null;
                cache.fourthLevelName = null;
            } else {
                target.thirdLevelCode = cache.thirdLevelCode;
                target.thirdLevelName = cache.thirdLevelName;
            }

            // 判断设备是否存在
            if (StringUtils.isNotBlank(target.thirdLevelCode)
                    && StringUtils.isNotBlank(target.thirdLevelName)
                    && !equipmentCodes.contains(target.thirdLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.thirdLevelCode);
                model.setName(target.thirdLevelName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.thirdLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                dataSource.put("imageClassification",target.secondLevelName);
                dataSource.put("relationshipObjectCategory",target.firstLevelName);
                dataSource.put("levelName","图");
                model.setDataSource(dataSource);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                equipmentCodes.add(target.thirdLevelCode);
            }
            // 判断设备是否存在
            if (StringUtils.isNotBlank(target.fourthLevelCode)
                    && StringUtils.isNotBlank(target.fourthLevelName)
                    && !equipmentCodes.contains(target.thirdLevelCode
                    +"-"+target.fourthLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.fourthLevelCode);
                model.setName(target.fourthLevelName);
                model.setCodePath(refKey+"-"+target.thirdLevelCode+"-"+target.fourthLevelCode);
                model.setParentCode(target.thirdLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                dataSource.put("imageClassification",target.secondLevelName);
                dataSource.put("relationshipObjectCategory",target.firstLevelName);
                dataSource.put("levelName","边");
                if (StringUtils.isNotBlank(edgeDirectivity)){
                    dataSource.put("edgeDirectivity",edgeDirectivity);
                }
                if (StringUtils.isNotBlank(propertyDirectivity)){
                    dataSource.put("propertyDirectivity",propertyDirectivity);
                }
                if (StringUtils.isNotBlank(mainObjRelation)){
                    dataSource.put("mainObjRelation",mainObjRelation);
                }
                if (StringUtils.isNotBlank(remark)){
                    dataSource.put("remark",remark);
                }
                model.setDataSource(dataSource);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                equipmentCodes.add(target.thirdLevelCode
                        +"-"+target.fourthLevelCode);
            }
        }
    }

    private void initSevenLevelData(List<RwdeditRefTypeInfosModel> models,String refKey,String sheetName) throws IOException {
        String classFile = basepath + "/附表18-推荐能耗模型表.xlsx";
        FileInputStream inputStream = new FileInputStream(classFile);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);
        if (sheet == null) {
            return;
        }

        // 行号从0开始, 从第2行开始读数据
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        Set<String> equipmentCodes = new HashSet<>();
        int startRowNum = 3;
        int lastRowNum = sheet.getLastRowNum();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.firstLevelCode = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 专业编码
            target.firstLevelName = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 专业名称
            target.secondLevelCode = (String) ExcelUtils.parseCell(row.getCell(4), "string");//系统类编码
            target.secondLevelName = (String) ExcelUtils.parseCell(row.getCell(3), "string");//系统类名称
            target.thirdLevelCode = (String) ExcelUtils.parseCell(row.getCell(6), "string");//设备设施类编码
            target.thirdLevelName = (String) ExcelUtils.parseCell(row.getCell(5), "string");//设备设施类名称
            target.fourthLevelCode = (String) ExcelUtils.parseCell(row.getCell(8), "string");//设备设施类编码
            target.fourthLevelName = (String) ExcelUtils.parseCell(row.getCell(7), "string");//设备设施类名称
            target.fifthLevelCode = (String) ExcelUtils.parseCell(row.getCell(10), "string");//设备设施类编码
            target.fifthLevelName = (String) ExcelUtils.parseCell(row.getCell(9), "string");//设备设施类名称
            target.sixthLevelCode = (String) ExcelUtils.parseCell(row.getCell(12), "string");//设备设施类编码
            target.sixthLevelName = (String) ExcelUtils.parseCell(row.getCell(11), "string");//设备设施类名称
            target.seventhLevelCode = (String) ExcelUtils.parseCell(row.getCell(14), "string");//设备设施类编码
            target.seventhLevelName = (String) ExcelUtils.parseCell(row.getCell(13), "string");//设备设施类名称
            String areaCode = (String) ExcelUtils.parseCell(row.getCell(15), "string");//设备设施类名称
            String areaName = (String) ExcelUtils.parseCell(row.getCell(16), "string");//设备设施类名称

            // 专业不为空
            if (target.firstLevelCode != null) {
                cache.firstLevelCode = target.firstLevelCode;
                cache.firstLevelName = target.firstLevelName;
                cache.secondLevelCode = null;
                cache.secondLevelName = null;
                cache.thirdLevelCode = null;
                cache.thirdLevelName = null;
                cache.fourthLevelCode = null;
                cache.fourthLevelName = null;
                cache.fifthLevelCode = null;
                cache.fifthLevelName = null;
                cache.sixthLevelCode = null;
                cache.sixthLevelName = null;
                cache.seventhLevelCode = null;
                cache.seventhLevelName = null;
            } else {
                target.firstLevelCode = cache.firstLevelCode;
                target.firstLevelName = cache.firstLevelName;
            }
            // 系统不为空
            if (target.secondLevelCode != null) {
                cache.secondLevelCode = target.secondLevelCode;
                cache.secondLevelName = target.secondLevelName;
                cache.thirdLevelCode = null;
                cache.thirdLevelName = null;
                cache.fourthLevelCode = null;
                cache.fourthLevelName = null;
                cache.fifthLevelCode = null;
                cache.fifthLevelName = null;
                cache.sixthLevelCode = null;
                cache.sixthLevelName = null;
                cache.seventhLevelCode = null;
                cache.seventhLevelName = null;
            } else {
                target.secondLevelCode = cache.secondLevelCode;
                target.secondLevelName = cache.secondLevelName;
            }
            // 系统不为空
            if (target.thirdLevelCode != null) {
                cache.thirdLevelCode = target.thirdLevelCode;
                cache.thirdLevelName = target.thirdLevelName;
                cache.fourthLevelCode = null;
                cache.fourthLevelName = null;
                cache.fifthLevelCode = null;
                cache.fifthLevelName = null;
                cache.sixthLevelCode = null;
                cache.sixthLevelName = null;
                cache.seventhLevelCode = null;
                cache.seventhLevelName = null;
            } else {
                target.thirdLevelCode = cache.thirdLevelCode;
                target.thirdLevelName = cache.thirdLevelName;
            }
            // 系统不为空
            if (target.fourthLevelCode != null) {
                cache.fourthLevelCode = target.fourthLevelCode;
                cache.fourthLevelName = target.fourthLevelName;
                cache.fifthLevelCode = null;
                cache.fifthLevelName = null;
                cache.sixthLevelCode = null;
                cache.sixthLevelName = null;
                cache.seventhLevelCode = null;
                cache.seventhLevelName = null;
            } else {
                target.fourthLevelCode = cache.fourthLevelCode;
                target.fourthLevelName = cache.fourthLevelName;
            }
            // 系统不为空
            if (target.fifthLevelCode != null) {
                cache.fifthLevelCode = target.fifthLevelCode;
                cache.fifthLevelName = target.fifthLevelName;
                cache.sixthLevelCode = null;
                cache.sixthLevelName = null;
                cache.seventhLevelCode = null;
                cache.seventhLevelName = null;
            } else {
                target.fifthLevelCode = cache.fifthLevelCode;
                target.fifthLevelName = cache.fifthLevelName;
            }
            // 系统不为空
            if (target.sixthLevelCode != null) {
                cache.sixthLevelCode = target.sixthLevelCode;
                cache.sixthLevelName = target.sixthLevelName;
                cache.seventhLevelCode = null;
                cache.seventhLevelName = null;
            } else {
                target.sixthLevelCode = cache.sixthLevelCode;
                target.sixthLevelName = cache.sixthLevelName;
            }

            // 判断专业是否存在
            if (StringUtils.isNotBlank(target.firstLevelCode)
                    && StringUtils.isNotBlank(target.firstLevelName)
                    && !majorCodes.contains(target.firstLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.firstLevelCode);
                model.setName(target.firstLevelName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.firstLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.secondLevelCode)
                    && StringUtils.isBlank(target.thirdLevelCode)
                    && StringUtils.isBlank(target.fourthLevelCode)
                    && StringUtils.isBlank(target.fifthLevelCode)
                    && StringUtils.isBlank(target.sixthLevelCode)
                    && StringUtils.isBlank(target.seventhLevelCode)){
                    if (StringUtils.isNotBlank(areaCode)){
                        dataSource.put("areaCode",areaCode);
                    }
                    if (StringUtils.isNotBlank(areaName)){
                        dataSource.put("areaName",areaName);
                    }
                }
                dataSource.put("levelName","第一级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                majorCodes.add(target.firstLevelCode);
            }
            // 判断系统是否存在
            if (StringUtils.isNotBlank(target.secondLevelCode)
                    && StringUtils.isNotBlank(target.secondLevelName)
                    && !systemCodes.contains(target.firstLevelCode+"-"+target.secondLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.secondLevelCode);
                model.setName(target.secondLevelName);
                model.setParentCode(target.firstLevelCode);
                model.setCodePath(refKey+"-"+target.firstLevelCode+"-"+target.secondLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.thirdLevelCode)
                        && StringUtils.isBlank(target.fourthLevelCode)
                        && StringUtils.isBlank(target.fifthLevelCode)
                        && StringUtils.isBlank(target.sixthLevelCode)
                        && StringUtils.isBlank(target.seventhLevelCode)){
                    if (StringUtils.isNotBlank(areaCode)){
                        dataSource.put("areaCode",areaCode);
                    }
                    if (StringUtils.isNotBlank(areaName)){
                        dataSource.put("areaName",areaName);
                    }
                }
                dataSource.put("levelName","第二级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                systemCodes.add(target.firstLevelCode+"-"+target.secondLevelCode);
            }

            // 判断设备是否存在
            if (StringUtils.isNotBlank(target.thirdLevelCode)
                    && StringUtils.isNotBlank(target.thirdLevelName)
                    && !equipmentCodes.contains(target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.thirdLevelCode);
                model.setName(target.thirdLevelName);
                model.setParentCode(target.secondLevelCode);
                model.setCodePath(refKey+"-"+target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.fourthLevelCode)
                        && StringUtils.isBlank(target.fifthLevelCode)
                        && StringUtils.isBlank(target.sixthLevelCode)
                        && StringUtils.isBlank(target.seventhLevelCode)){
                    if (StringUtils.isNotBlank(areaCode)){
                        dataSource.put("areaCode",areaCode);
                    }
                    if (StringUtils.isNotBlank(areaName)){
                        dataSource.put("areaName",areaName);
                    }
                }
                dataSource.put("levelName","第三级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                equipmentCodes.add(target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode);
            }
            // 判断设备是否存在
            if (StringUtils.isNotBlank(target.fourthLevelCode)
                    && StringUtils.isNotBlank(target.fourthLevelName)
                    && !equipmentCodes.contains(target.firstLevelCode
                    +"-"+target.secondLevelCode
                    +"-"+target.thirdLevelCode
                    +"-"+target.fourthLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.fourthLevelCode);
                model.setName(target.fourthLevelName);
                model.setCodePath(refKey+"-"+target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode+"-"+target.fourthLevelCode);
                model.setParentCode(target.thirdLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.fifthLevelCode)
                        && StringUtils.isBlank(target.sixthLevelCode)
                        && StringUtils.isBlank(target.seventhLevelCode)){
                    if (StringUtils.isNotBlank(areaCode)){
                        dataSource.put("areaCode",areaCode);
                    }
                    if (StringUtils.isNotBlank(areaName)){
                        dataSource.put("areaName",areaName);
                    }
                }
                dataSource.put("levelName","第四级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                equipmentCodes.add(target.firstLevelCode
                        +"-"+target.secondLevelCode
                        +"-"+target.thirdLevelCode
                        +"-"+target.fourthLevelCode);
            }
            // 判断设备是否存在
            if (StringUtils.isNotBlank(target.fifthLevelCode)
                    && StringUtils.isNotBlank(target.fifthLevelName)
                    && !equipmentCodes.contains(target.firstLevelCode
                    +"-"+target.secondLevelCode
                    +"-"+target.thirdLevelCode
                    +"-"+target.fourthLevelCode
                    +"-"+target.fifthLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.fifthLevelCode);
                model.setName(target.fifthLevelName);
                model.setCodePath(refKey+"-"+target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode+"-"+target.fourthLevelCode+"-"+target.fifthLevelCode);
                model.setParentCode(target.fourthLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.sixthLevelCode)
                        && StringUtils.isBlank(target.seventhLevelCode)){
                    if (StringUtils.isNotBlank(areaCode)){
                        dataSource.put("areaCode",areaCode);
                    }
                    if (StringUtils.isNotBlank(areaName)){
                        dataSource.put("areaName",areaName);
                    }
                }
                dataSource.put("levelName","第五级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                equipmentCodes.add(target.firstLevelCode
                        +"-"+target.secondLevelCode
                        +"-"+target.thirdLevelCode
                        +"-"+target.fourthLevelCode
                        +"-"+target.fifthLevelCode);
            }
            // 判断设备是否存在
            if (StringUtils.isNotBlank(target.sixthLevelCode)
                    && StringUtils.isNotBlank(target.sixthLevelName)
                    && !equipmentCodes.contains(target.firstLevelCode
                    +"-"+target.secondLevelCode
                    +"-"+target.thirdLevelCode
                    +"-"+target.fourthLevelCode
                    +"-"+target.fifthLevelCode
                    +"-"+target.sixthLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.sixthLevelCode);
                model.setName(target.sixthLevelName);
                model.setCodePath("-9999"
                        +"-"+target.firstLevelCode
                        +"-"+target.secondLevelCode
                        +"-"+target.thirdLevelCode
                        +"-"+target.fourthLevelCode
                        +"-"+target.fifthLevelCode
                        +"-"+target.sixthLevelCode);
                model.setParentCode(target.fifthLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.seventhLevelCode)){
                    if (StringUtils.isNotBlank(areaCode)){
                        dataSource.put("areaCode",areaCode);
                    }
                    if (StringUtils.isNotBlank(areaName)){
                        dataSource.put("areaName",areaName);
                    }
                }
                dataSource.put("levelName","第六级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                equipmentCodes.add(target.firstLevelCode
                        +"-"+target.secondLevelCode
                        +"-"+target.thirdLevelCode
                        +"-"+target.fourthLevelCode
                        +"-"+target.fifthLevelCode
                        +"-"+target.sixthLevelCode);
            }
            // 判断设备是否存在
            if (StringUtils.isNotBlank(target.seventhLevelCode)
                    && StringUtils.isNotBlank(target.seventhLevelName)
                    && !equipmentCodes.contains(target.firstLevelCode
                    +"-"+target.secondLevelCode
                    +"-"+target.thirdLevelCode
                    +"-"+target.fourthLevelCode
                    +"-"+target.fifthLevelCode
                    +"-"+target.sixthLevelCode
                    +"-"+target.seventhLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.seventhLevelCode);
                model.setName(target.seventhLevelName);
                model.setCodePath("-9999"
                        +"-"+target.firstLevelCode
                        +"-"+target.secondLevelCode
                        +"-"+target.thirdLevelCode
                        +"-"+target.fourthLevelCode
                        +"-"+target.fifthLevelCode
                        +"-"+target.sixthLevelCode
                        +"-"+target.seventhLevelCode);
                model.setParentCode(target.sixthLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isNotBlank(areaCode)){
                    dataSource.put("areaCode",areaCode);
                }
                if (StringUtils.isNotBlank(areaName)){
                    dataSource.put("areaName",areaName);
                }
                dataSource.put("levelName","第七级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                equipmentCodes.add(target.firstLevelCode
                        +"-"+target.secondLevelCode
                        +"-"+target.thirdLevelCode
                        +"-"+target.fourthLevelCode
                        +"-"+target.fifthLevelCode
                        +"-"+target.sixthLevelCode
                        +"-"+target.seventhLevelCode);
            }

        }
    }

    private void initFiveLevelData(List<RwdeditRefTypeInfosModel> models,String refKey,String sheetName) throws IOException {
        String classFile = basepath + "/附表18-推荐能耗模型表.xlsx";
        FileInputStream inputStream = new FileInputStream(classFile);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);
        if (sheet == null) {
            return;
        }

        // 行号从0开始, 从第2行开始读数据
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        Set<String> equipmentCodes = new HashSet<>();
        int startRowNum = 3;
        int lastRowNum = sheet.getLastRowNum();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.firstLevelCode = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 专业编码
            target.firstLevelName = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 专业名称
            target.secondLevelCode = (String) ExcelUtils.parseCell(row.getCell(4), "string");//系统类编码
            target.secondLevelName = (String) ExcelUtils.parseCell(row.getCell(3), "string");//系统类名称
            target.thirdLevelCode = (String) ExcelUtils.parseCell(row.getCell(6), "string");//设备设施类编码
            target.thirdLevelName = (String) ExcelUtils.parseCell(row.getCell(5), "string");//设备设施类名称
            target.fourthLevelCode = (String) ExcelUtils.parseCell(row.getCell(8), "string");//设备设施类编码
            target.fourthLevelName = (String) ExcelUtils.parseCell(row.getCell(7), "string");//设备设施类名称
            target.fifthLevelCode = (String) ExcelUtils.parseCell(row.getCell(10), "string");//设备设施类编码
            target.fifthLevelName = (String) ExcelUtils.parseCell(row.getCell(9), "string");//设备设施类名称
            String areaCode = (String) ExcelUtils.parseCell(row.getCell(12), "string");//设备设施类编码
            String areaName = (String) ExcelUtils.parseCell(row.getCell(11), "string");//设备设施类名称

            // 专业不为空
            if (target.firstLevelCode != null) {
                cache.firstLevelCode = target.firstLevelCode;
                cache.firstLevelName = target.firstLevelName;
                cache.secondLevelCode = null;
                cache.secondLevelName = null;
                cache.thirdLevelCode = null;
                cache.thirdLevelName = null;
                cache.fourthLevelCode = null;
                cache.fourthLevelName = null;
                cache.fifthLevelCode = null;
                cache.fifthLevelName = null;
            } else {
                target.firstLevelCode = cache.firstLevelCode;
                target.firstLevelName = cache.firstLevelName;
            }
            // 系统不为空
            if (target.secondLevelCode != null) {
                cache.secondLevelCode = target.secondLevelCode;
                cache.secondLevelName = target.secondLevelName;
                cache.thirdLevelCode = null;
                cache.thirdLevelName = null;
                cache.fourthLevelCode = null;
                cache.fourthLevelName = null;
                cache.fifthLevelCode = null;
                cache.fifthLevelName = null;
            } else {
                target.secondLevelCode = cache.secondLevelCode;
                target.secondLevelName = cache.secondLevelName;
            }
            // 系统不为空
            if (target.thirdLevelCode != null) {
                cache.thirdLevelCode = target.thirdLevelCode;
                cache.thirdLevelName = target.thirdLevelName;
                cache.fourthLevelCode = null;
                cache.fourthLevelName = null;
                cache.fifthLevelCode = null;
                cache.fifthLevelName = null;
            } else {
                target.thirdLevelCode = cache.thirdLevelCode;
                target.thirdLevelName = cache.thirdLevelName;
            }
            // 系统不为空
            if (target.fourthLevelCode != null) {
                cache.fourthLevelCode = target.fourthLevelCode;
                cache.fourthLevelName = target.fourthLevelName;
                cache.fifthLevelCode = null;
                cache.fifthLevelName = null;
            } else {
                target.fourthLevelCode = cache.fourthLevelCode;
                target.fourthLevelName = cache.fourthLevelName;
            }

            // 判断专业是否存在
            if (StringUtils.isNotBlank(target.firstLevelCode)
                    && StringUtils.isNotBlank(target.firstLevelName)
                    && !majorCodes.contains(target.firstLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.firstLevelCode);
                model.setName(target.firstLevelName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.firstLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.secondLevelCode)
                        && StringUtils.isBlank(target.thirdLevelCode)
                        && StringUtils.isBlank(target.fourthLevelCode)
                        && StringUtils.isBlank(target.fifthLevelCode)){
                    if (StringUtils.isNotBlank(areaCode)){
                        dataSource.put("areaCode",areaCode);
                    }
                    if (StringUtils.isNotBlank(areaName)){
                        dataSource.put("areaName",areaName);
                    }
                }
                dataSource.put("levelName","第一级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                majorCodes.add(target.firstLevelCode);
            }
            // 判断系统是否存在
            if (StringUtils.isNotBlank(target.secondLevelCode)
                    && StringUtils.isNotBlank(target.secondLevelName)
                    && !systemCodes.contains(target.firstLevelCode+"-"+target.secondLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.secondLevelCode);
                model.setName(target.secondLevelName);
                model.setParentCode(target.firstLevelCode);
                model.setCodePath(refKey+"-"+target.firstLevelCode+"-"+target.secondLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.thirdLevelCode)
                        && StringUtils.isBlank(target.fourthLevelCode)
                        && StringUtils.isBlank(target.fifthLevelCode)){
                    if (StringUtils.isNotBlank(areaCode)){
                        dataSource.put("areaCode",areaCode);
                    }
                    if (StringUtils.isNotBlank(areaName)){
                        dataSource.put("areaName",areaName);
                    }
                }
                dataSource.put("levelName","第二级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                systemCodes.add(target.firstLevelCode+"-"+target.secondLevelCode);
            }

            // 判断设备是否存在
            if (StringUtils.isNotBlank(target.thirdLevelCode)
                    && StringUtils.isNotBlank(target.thirdLevelName)
                    && !equipmentCodes.contains(target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.thirdLevelCode);
                model.setName(target.thirdLevelName);
                model.setParentCode(target.secondLevelCode);
                model.setCodePath(refKey+"-"+target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.fourthLevelCode)
                        && StringUtils.isBlank(target.fifthLevelCode)){
                    if (StringUtils.isNotBlank(areaCode)){
                        dataSource.put("areaCode",areaCode);
                    }
                    if (StringUtils.isNotBlank(areaName)){
                        dataSource.put("areaName",areaName);
                    }
                }
                dataSource.put("levelName","第三级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                equipmentCodes.add(target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode);
            }
            // 判断设备是否存在
            if (StringUtils.isNotBlank(target.fourthLevelCode)
                    && StringUtils.isNotBlank(target.fourthLevelName)
                    && !equipmentCodes.contains(target.firstLevelCode
                    +"-"+target.secondLevelCode
                    +"-"+target.thirdLevelCode
                    +"-"+target.fourthLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.fourthLevelCode);
                model.setName(target.fourthLevelName);
                model.setCodePath(refKey+"-"+target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode+"-"+target.fourthLevelCode);
                model.setParentCode(target.thirdLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.fifthLevelCode)){
                    if (StringUtils.isNotBlank(areaCode)){
                        dataSource.put("areaCode",areaCode);
                    }
                    if (StringUtils.isNotBlank(areaName)){
                        dataSource.put("areaName",areaName);
                    }
                }
                dataSource.put("levelName","第四级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                equipmentCodes.add(target.firstLevelCode
                        +"-"+target.secondLevelCode
                        +"-"+target.thirdLevelCode
                        +"-"+target.fourthLevelCode);
            }
            // 判断设备是否存在
            if (StringUtils.isNotBlank(target.fifthLevelCode)
                    && StringUtils.isNotBlank(target.fifthLevelName)
                    && !equipmentCodes.contains(target.firstLevelCode
                    +"-"+target.secondLevelCode
                    +"-"+target.thirdLevelCode
                    +"-"+target.fourthLevelCode
                    +"-"+target.fifthLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.fifthLevelCode);
                model.setName(target.fifthLevelName);
                model.setCodePath(refKey+"-"+target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode+"-"+target.fourthLevelCode+"-"+target.fifthLevelCode);
                model.setParentCode(target.fourthLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isNotBlank(areaCode)){
                    dataSource.put("areaCode",areaCode);
                }
                if (StringUtils.isNotBlank(areaName)){
                    dataSource.put("areaName",areaName);
                }
                dataSource.put("levelName","第五级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                equipmentCodes.add(target.firstLevelCode
                        +"-"+target.secondLevelCode
                        +"-"+target.thirdLevelCode
                        +"-"+target.fourthLevelCode
                        +"-"+target.fifthLevelCode);
            }
        }
    }

    private void initFourLevelData(List<RwdeditRefTypeInfosModel> models,String refKey,String sheetName) throws IOException {
        String classFile = basepath + "/附表18-推荐能耗模型表.xlsx";
        FileInputStream inputStream = new FileInputStream(classFile);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);
        if (sheet == null) {
            return;
        }

        // 行号从0开始, 从第2行开始读数据
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        Set<String> equipmentCodes = new HashSet<>();
        int startRowNum = 3;
        int lastRowNum = sheet.getLastRowNum();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.firstLevelCode = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 专业编码
            target.firstLevelName = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 专业名称
            target.secondLevelCode = (String) ExcelUtils.parseCell(row.getCell(4), "string");//系统类编码
            target.secondLevelName = (String) ExcelUtils.parseCell(row.getCell(3), "string");//系统类名称
            target.thirdLevelCode = (String) ExcelUtils.parseCell(row.getCell(6), "string");//设备设施类编码
            target.thirdLevelName = (String) ExcelUtils.parseCell(row.getCell(5), "string");//设备设施类名称
            target.fourthLevelCode = (String) ExcelUtils.parseCell(row.getCell(8), "string");//设备设施类编码
            target.fourthLevelName = (String) ExcelUtils.parseCell(row.getCell(7), "string");//设备设施类名称

            // 专业不为空
            if (target.firstLevelCode != null) {
                cache.firstLevelCode = target.firstLevelCode;
                cache.firstLevelName = target.firstLevelName;
                cache.secondLevelCode = null;
                cache.secondLevelName = null;
                cache.thirdLevelCode = null;
                cache.thirdLevelName = null;
                cache.fourthLevelCode = null;
                cache.fourthLevelName = null;
            } else {
                target.firstLevelCode = cache.firstLevelCode;
                target.firstLevelName = cache.firstLevelName;
            }
            // 系统不为空
            if (target.secondLevelCode != null) {
                cache.secondLevelCode = target.secondLevelCode;
                cache.secondLevelName = target.secondLevelName;
                cache.thirdLevelCode = null;
                cache.thirdLevelName = null;
                cache.fourthLevelCode = null;
                cache.fourthLevelName = null;
            } else {
                target.secondLevelCode = cache.secondLevelCode;
                target.secondLevelName = cache.secondLevelName;
            }
            // 系统不为空
            if (target.thirdLevelCode != null) {
                cache.thirdLevelCode = target.thirdLevelCode;
                cache.thirdLevelName = target.thirdLevelName;
                cache.fourthLevelCode = null;
                cache.fourthLevelName = null;
            } else {
                target.thirdLevelCode = cache.thirdLevelCode;
                target.thirdLevelName = cache.thirdLevelName;
            }

            // 判断专业是否存在
            if (StringUtils.isNotBlank(target.firstLevelCode)
                    && StringUtils.isNotBlank(target.firstLevelName)
                    && !majorCodes.contains(target.firstLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.firstLevelCode);
                model.setName(target.firstLevelName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.firstLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                dataSource.put("levelName","第一级");
                model.setDataSource(dataSource);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                majorCodes.add(target.firstLevelCode);
            }

            // 判断系统是否存在
            if (StringUtils.isNotBlank(target.secondLevelCode)
                    && StringUtils.isNotBlank(target.secondLevelName)
                    && !systemCodes.contains(target.firstLevelCode+"-"+target.secondLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.secondLevelCode);
                model.setName(target.secondLevelName);
                model.setParentCode(target.firstLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                dataSource.put("levelName","第二级");
                model.setDataSource(dataSource);
                model.setCodePath(refKey+"-"+target.firstLevelCode+"-"+target.secondLevelCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                systemCodes.add(target.firstLevelCode+"-"+target.secondLevelCode);
            }

            // 判断设备是否存在
            if (StringUtils.isNotBlank(target.thirdLevelCode)
                    && StringUtils.isNotBlank(target.thirdLevelName)
                    && !equipmentCodes.contains(target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.thirdLevelCode);
                model.setName(target.thirdLevelName);
                model.setParentCode(target.secondLevelCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                dataSource.put("levelName","第三级");
                model.setDataSource(dataSource);
                model.setCodePath(refKey+"-"+target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                equipmentCodes.add(target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode);
            }
            // 判断设备是否存在
            if (StringUtils.isNotBlank(target.fourthLevelCode)
                    && StringUtils.isNotBlank(target.fourthLevelName)
                    && !equipmentCodes.contains(target.firstLevelCode
                    +"-"+target.secondLevelCode
                    +"-"+target.thirdLevelCode
                    +"-"+target.fourthLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.fourthLevelCode);
                model.setName(target.fourthLevelName);
                ObjectNode dataSource = objectMapper.createObjectNode();
                dataSource.put("levelName","第四级");
                model.setDataSource(dataSource);
                model.setCodePath(refKey+"-"+target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode+"-"+target.fourthLevelCode);
                model.setParentCode(target.thirdLevelCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                equipmentCodes.add(target.firstLevelCode
                        +"-"+target.secondLevelCode
                        +"-"+target.thirdLevelCode
                        +"-"+target.fourthLevelCode);
            }
        }
    }

    private void initThreeLevelData(List<RwdeditRefTypeInfosModel> models,String refKey,String sheetName) throws IOException {
        String classFile = basepath + "/附表18-推荐能耗模型表.xlsx";
        FileInputStream inputStream = new FileInputStream(classFile);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);
        if (sheet == null) {
            return;
        }

        // 行号从0开始, 从第2行开始读数据
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        Set<String> equipmentCodes = new HashSet<>();
        int startRowNum = 3;
        int lastRowNum = sheet.getLastRowNum();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.firstLevelCode = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 专业编码
            target.firstLevelName = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 专业名称
            target.secondLevelCode = (String) ExcelUtils.parseCell(row.getCell(4), "string");//系统类编码
            target.secondLevelName = (String) ExcelUtils.parseCell(row.getCell(3), "string");//系统类名称
            target.thirdLevelCode = (String) ExcelUtils.parseCell(row.getCell(6), "string");//设备设施类编码
            target.thirdLevelName = (String) ExcelUtils.parseCell(row.getCell(5), "string");//设备设施类名称
            String remark = (String) ExcelUtils.parseCell(row.getCell(7), "string");//设备设施类名称
            String configRequire = (String) ExcelUtils.parseCell(row.getCell(8), "string");//调研配置要求

            // 专业不为空
            if (target.firstLevelCode != null) {
                cache.firstLevelCode = target.firstLevelCode;
                cache.firstLevelName = target.firstLevelName;
                cache.secondLevelCode = null;
                cache.secondLevelName = null;
                cache.thirdLevelCode = null;
                cache.thirdLevelName = null;
            } else {
                target.firstLevelCode = cache.firstLevelCode;
                target.firstLevelName = cache.firstLevelName;
            }
            // 系统不为空
            if (target.secondLevelCode != null) {
                cache.secondLevelCode = target.secondLevelCode;
                cache.secondLevelName = target.secondLevelName;
                cache.thirdLevelCode = null;
                cache.thirdLevelName = null;
            } else {
                target.secondLevelCode = cache.secondLevelCode;
                target.secondLevelName = cache.secondLevelName;
            }

            // 判断专业是否存在
            if (StringUtils.isNotBlank(target.firstLevelCode)
                    && StringUtils.isNotBlank(target.firstLevelName)
                    && !majorCodes.contains(target.firstLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.firstLevelCode);
                model.setName(target.firstLevelName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.firstLevelCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.secondLevelCode)
                        && StringUtils.isBlank(target.thirdLevelCode)){
                    if(StringUtils.isNotBlank(remark)){
                        dataSource.put("remark",remark);
                    }
                    if (StringUtils.isNotBlank(configRequire)){
                        dataSource.put("configRequire",configRequire);
                    }
                }
                dataSource.put("levelName","第一级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                models.add(model);
                majorCodes.add(target.firstLevelCode);
            }

            // 判断系统是否存在
            if (StringUtils.isNotBlank(target.secondLevelCode)
                    && StringUtils.isNotBlank(target.secondLevelName)
                    && !systemCodes.contains(target.firstLevelCode+"-"+target.secondLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.secondLevelCode);
                model.setName(target.secondLevelName);
                model.setParentCode(target.firstLevelCode);
                model.setCodePath(refKey+"-"+target.firstLevelCode+"-"+target.secondLevelCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.thirdLevelCode)){
                    if(StringUtils.isNotBlank(remark)){
                        dataSource.put("remark",remark);
                    }
                    if (StringUtils.isNotBlank(configRequire)){
                        dataSource.put("configRequire",configRequire);
                    }
                }
                dataSource.put("levelName","第二级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                models.add(model);
                systemCodes.add(target.firstLevelCode+"-"+target.secondLevelCode);
            }

            // 判断设备是否存在
            if (StringUtils.isNotBlank(target.thirdLevelCode)
                    && StringUtils.isNotBlank(target.thirdLevelName)
                    && !equipmentCodes.contains(target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.thirdLevelCode);
                model.setName(target.thirdLevelName);
                model.setParentCode(target.secondLevelCode);
                model.setCodePath(refKey+"-"+target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if(StringUtils.isNotBlank(remark)){
                    dataSource.put("remark",remark);
                }
                if (StringUtils.isNotBlank(configRequire)){
                    dataSource.put("configRequire",configRequire);
                }
                dataSource.put("levelName","第三级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                models.add(model);
                equipmentCodes.add(target.firstLevelCode+"-"+target.secondLevelCode+"-"+target.thirdLevelCode);
            }
        }
    }

    private void initCommercialLeasingType(List<RwdeditRefTypeInfosModel> models,String refKey,String sheetName) throws IOException {
        String classFile = basepath + "/附表17-推荐空间业态分类表.xlsx";
        FileInputStream inputStream = new FileInputStream(classFile);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);
        if (sheet == null) {
            return;
        }

        // 行号从0开始, 从第2行开始读数据
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        Set<String> equipmentCodes = new HashSet<>();
        int startRowNum = 3;
        int lastRowNum = sheet.getLastRowNum();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.majorCode = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 专业编码
            target.majorName = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 专业名称
            target.systemCode = (String) ExcelUtils.parseCell(row.getCell(4), "string");//系统类编码
            target.systemName = (String) ExcelUtils.parseCell(row.getCell(3), "string");//系统类名称
            target.equipCode = (String) ExcelUtils.parseCell(row.getCell(6), "string");//设备设施类编码
            target.equipName = (String) ExcelUtils.parseCell(row.getCell(5), "string");//设备设施类名称
            String typicalShops = (String) ExcelUtils.parseCell(row.getCell(7), "string");//设备设施类名称
            String classificationReason = (String) ExcelUtils.parseCell(row.getCell(8), "string");//设备设施类名称

            // 专业不为空
            if (target.majorCode != null) {
                cache.majorCode = target.majorCode;
                cache.majorName = target.majorName;
                cache.systemCode = null;
                cache.systemName = null;
                cache.equipCode = null;
                cache.equipName = null;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.majorCode = cache.majorCode;
                target.majorName = cache.majorName;
            }
            // 系统不为空
            if (target.systemCode != null) {
                cache.systemCode = target.systemCode;
                cache.systemName = target.systemName;
                cache.equipCode = null;
                cache.equipName = null;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.systemCode = cache.systemCode;
                target.systemName = cache.systemName;
            }

            // 判断专业是否存在
            if (!majorCodes.contains(target.majorCode)
                    && StringUtils.isNotBlank(target.majorCode)
                    && StringUtils.isNotBlank(target.majorName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.majorCode);
                model.setName(target.majorName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.majorCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.systemCode)
                        && StringUtils.isBlank(target.equipCode)){
                    if (StringUtils.isNotBlank(typicalShops)){
                        dataSource.put("typicalShops",typicalShops);
                    }
                    if (StringUtils.isNotBlank(classificationReason)){
                        dataSource.put("classificationReason",classificationReason);
                    }

                }
                dataSource.put("levelName","第一级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                models.add(model);
                majorCodes.add(target.majorCode);
            }

            // 判断系统是否存在
            if (!systemCodes.contains(target.majorCode+"-"+target.systemCode)
                    && StringUtils.isNotBlank(target.systemCode)
                    && StringUtils.isNotBlank(target.systemName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.systemCode);
                model.setName(target.systemName);
                model.setParentCode(target.majorCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.equipCode)){
                    if (StringUtils.isNotBlank(typicalShops)){
                        dataSource.put("typicalShops",typicalShops);
                    }
                    if (StringUtils.isNotBlank(classificationReason)){
                        dataSource.put("classificationReason",classificationReason);
                    }
                }
                dataSource.put("levelName","第二级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                models.add(model);
                systemCodes.add(target.majorCode+"-"+target.systemCode);
            }

            // 判断设备是否存在
            if (!equipmentCodes.contains(target.majorCode+"-"+target.systemCode+"-"+target.equipCode)
                    && StringUtils.isNotBlank(target.equipCode)
                    && StringUtils.isNotBlank(target.equipName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.equipCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode+"-"+target.equipCode);
                model.setName(target.equipName);
                model.setParentCode(target.systemCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isNotBlank(typicalShops)){
                    dataSource.put("typicalShops",typicalShops);
                }
                if (StringUtils.isNotBlank(classificationReason)){
                    dataSource.put("classificationReason",classificationReason);
                }
                dataSource.put("levelName","第三级");
                if (dataSource.size()>0){
                    model.setDataSource(dataSource);
                }
                models.add(model);
                equipmentCodes.add(target.majorCode+"-"+target.systemCode+"-"+target.equipCode);
            }
        }
    }

    private void initSpaceFuncType(List<RwdeditRefTypeInfosModel> models,String refKey,String sheetName) throws IOException {
        String classFile = basepath + "/附表17-推荐空间业态分类表.xlsx";
        FileInputStream inputStream = new FileInputStream(classFile);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);
        if (sheet == null) {
            return;
        }

        // 行号从0开始, 从第2行开始读数据
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        Set<String> equipmentCodes = new HashSet<>();
        int startRowNum = 3;
        int lastRowNum = sheet.getLastRowNum();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.majorCode = (String) ExcelUtils.parseCell(row.getCell(3), "string");// 专业编码
            target.majorName = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 专业名称
            target.systemCode = (String) ExcelUtils.parseCell(row.getCell(5), "string");//系统类编码
            target.systemName = (String) ExcelUtils.parseCell(row.getCell(4), "string");//系统类名称
            target.equipCode = (String) ExcelUtils.parseCell(row.getCell(7), "string");//设备设施类编码
            target.equipName = (String) ExcelUtils.parseCell(row.getCell(6), "string");//设备设施类名称
            target.componentCode = (String) ExcelUtils.parseCell(row.getCell(9), "string");//设备设施类编码
            target.componentName = (String) ExcelUtils.parseCell(row.getCell(8), "string");//设备设施类名称
            target.extendName = (String) ExcelUtils.parseCell(row.getCell(1), "string");//设备设施类名称

            if (target.extendName != null) {
                cache.extendName = target.extendName;
            } else {
                target.extendName = cache.extendName;
            }

            // 专业不为空
            if (target.majorCode != null) {
                cache.majorCode = target.majorCode;
                cache.majorName = target.majorName;
                cache.systemCode = null;
                cache.systemName = null;
                cache.equipCode = null;
                cache.equipName = null;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.majorCode = cache.majorCode;
                target.majorName = cache.majorName;
            }
            // 系统不为空
            if (target.systemCode != null) {
                cache.systemCode = target.systemCode;
                cache.systemName = target.systemName;
                cache.equipCode = null;
                cache.equipName = null;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.systemCode = cache.systemCode;
                target.systemName = cache.systemName;
            }
            // 设备不为空
            if (target.equipCode != null) {
                cache.equipCode = target.equipCode;
                cache.equipName = target.equipName;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.equipCode = cache.equipCode;
                target.equipName = cache.equipName;
            }

            // 判断专业是否存在
            if (StringUtils.isNotBlank(target.majorCode)
                    && StringUtils.isNotBlank(target.majorName)
                    && !majorCodes.contains(target.majorCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.majorCode);
                model.setName(target.majorName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.majorCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isNotBlank(target.extendName)
                        /*&& StringUtils.isBlank(target.systemCode)
                        && StringUtils.isBlank(target.equipCode)
                        && StringUtils.isBlank(target.componentCode)*/){
                    dataSource.put("classification",target.extendName);
                }
                dataSource.put("levelName","第一级");
                model.setDataSource(dataSource);
                models.add(model);
                majorCodes.add(target.majorCode);
            }

            // 判断系统是否存在
            if (StringUtils.isNotBlank(target.systemCode)
                    && StringUtils.isNotBlank(target.systemName)
                    && !systemCodes.contains(target.majorCode+"-"+target.systemCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.systemCode);
                model.setName(target.systemName);
                model.setParentCode(target.majorCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isNotBlank(target.extendName)
                        /*&& StringUtils.isBlank(target.equipCode)
                        && StringUtils.isBlank(target.componentCode)*/){
                    dataSource.put("classification",target.extendName);
                }
                dataSource.put("levelName","第二级");
                model.setDataSource(dataSource);
                models.add(model);
                systemCodes.add(target.majorCode+"-"+target.systemCode);
            }

            // 判断设备是否存在
            if (StringUtils.isNotBlank(target.equipCode)
                    && StringUtils.isNotBlank(target.equipName)
                    && !equipmentCodes.contains(target.majorCode+"-"+target.systemCode+"-"+target.equipCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.equipCode);
                model.setName(target.equipName);
                model.setParentCode(target.systemCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode+"-"+target.equipCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isNotBlank(target.extendName)
                       /* && StringUtils.isBlank(target.componentCode)*/){
                    dataSource.put("classification",target.extendName);
                }
                dataSource.put("levelName","第三级");
                model.setDataSource(dataSource);
                models.add(model);
                equipmentCodes.add(target.majorCode+"-"+target.systemCode+"-"+target.equipCode);
            }
            // 判断设备是否存在
            if (StringUtils.isNotBlank(target.componentCode)
                    && StringUtils.isNotBlank(target.componentName)
                    && !equipmentCodes.contains(target.majorCode+"-"+target.systemCode+"-"+target.equipCode+"-"+target.componentCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.componentCode);
                model.setName(target.componentName);
                model.setParentCode(target.equipCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode+"-"+target.equipCode+"-"+target.componentCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isNotBlank(target.extendName)){
                    dataSource.put("classification",target.extendName);
                }
                dataSource.put("levelName","第四级");
                model.setDataSource(dataSource);
                models.add(model);
                equipmentCodes.add(target.majorCode+"-"+target.systemCode+"-"+target.equipCode+"-"+target.componentCode);
            }
        }
    }

    private void initBuildFuncType(List<RwdeditRefTypeInfosModel> models,String refKey,String sheetName) throws IOException {
        String classFile = basepath + "/附表17-推荐空间业态分类表.xlsx";
        FileInputStream inputStream = new FileInputStream(classFile);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);
        if (sheet == null) {
            return;
        }

        // 行号从0开始, 从第2行开始读数据
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        Set<String> equipmentCodes = new HashSet<>();
        int startRowNum = 3;
        int lastRowNum = sheet.getLastRowNum();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.majorCode = (String) ExcelUtils.parseCell(row.getCell(3), "string");// 专业编码
            target.majorName = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 专业名称
            target.systemCode = (String) ExcelUtils.parseCell(row.getCell(5), "string");//系统类编码
            target.systemName = (String) ExcelUtils.parseCell(row.getCell(4), "string");//系统类名称
            target.extendName = (String) ExcelUtils.parseCell(row.getCell(1), "string");//设备设施类名称

            // 专业不为空
            if (target.extendName != null) {
                cache.extendName = target.extendName;
            } else {
                target.extendName = cache.extendName;
            }

            // 专业不为空
            if (target.majorCode != null) {
                cache.majorCode = target.majorCode;
                cache.majorName = target.majorName;
                cache.systemCode = null;
                cache.systemName = null;
                cache.equipCode = null;
                cache.equipName = null;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.majorCode = cache.majorCode;
                target.majorName = cache.majorName;
            }
            // 判断专业是否存在
            if (!majorCodes.contains(target.majorCode)
                    && StringUtils.isNotBlank(target.majorCode)
                    && StringUtils.isNotBlank(target.majorName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.majorCode);
                model.setName(target.majorName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.majorCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isNotBlank(target.extendName)/* && StringUtils.isBlank(target.systemCode)*/){
                    dataSource.put("classification",target.extendName);
                }
                dataSource.put("levelName","第一级");
                model.setDataSource(dataSource);
                models.add(model);
                majorCodes.add(target.majorCode);
            }

            // 判断系统是否存在
            if (!systemCodes.contains(target.majorCode+"-"+target.systemCode)
                    && StringUtils.isNotBlank(target.systemCode)
                    && StringUtils.isNotBlank(target.systemName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.systemCode);
                model.setName(target.systemName);
                model.setParentCode(target.majorCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isNotBlank(target.extendName)){
                    dataSource.put("classification",target.extendName);
                }
                dataSource.put("levelName","第二级");
                model.setDataSource(dataSource);
                models.add(model);
                systemCodes.add(target.majorCode+"-"+target.systemCode);
            }
        }
    }
    private void initProjectType(List<RwdeditRefTypeInfosModel> models,String refKey,String sheetName) throws IOException {
        String classFile = basepath + "/附表17-推荐空间业态分类表.xlsx";
        FileInputStream inputStream = new FileInputStream(classFile);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);
        if (sheet == null) {
            return;
        }

        // 行号从0开始, 从第2行开始读数据
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        Set<String> equipmentCodes = new HashSet<>();
        int startRowNum = 3;
        int lastRowNum = sheet.getLastRowNum();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.majorCode = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 专业编码
            target.majorName = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 专业名称
            target.systemCode = (String) ExcelUtils.parseCell(row.getCell(4), "string");//系统类编码
            target.systemName = (String) ExcelUtils.parseCell(row.getCell(3), "string");//系统类名称
            target.equipCode = (String) ExcelUtils.parseCell(row.getCell(6), "string");//设备设施类编码
            target.equipName = (String) ExcelUtils.parseCell(row.getCell(5), "string");//设备设施类名称

            // 专业不为空
            if (target.majorCode != null) {
                cache.majorCode = target.majorCode;
                cache.majorName = target.majorName;
                cache.systemCode = null;
                cache.systemName = null;
                cache.equipCode = null;
                cache.equipName = null;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.majorCode = cache.majorCode;
                target.majorName = cache.majorName;
            }
            // 系统不为空
            if (target.systemCode != null) {
                cache.systemCode = target.systemCode;
                cache.systemName = target.systemName;
                cache.equipCode = null;
                cache.equipName = null;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.systemCode = cache.systemCode;
                target.systemName = cache.systemName;
            }

            // 判断专业是否存在
            if (!majorCodes.contains(target.majorCode)
                    && StringUtils.isNotBlank(target.majorCode)
                    && StringUtils.isNotBlank(target.majorName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.majorCode);
                model.setName(target.majorName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.majorCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                dataSource.put("levelName","第一级");
                model.setDataSource(dataSource);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                majorCodes.add(target.majorCode);
            }

            // 判断系统是否存在
            if (!systemCodes.contains(target.majorCode+"-"+target.systemCode)
                    && StringUtils.isNotBlank(target.systemCode)
                    && StringUtils.isNotBlank(target.systemName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.systemCode);
                model.setName(target.systemName);
                model.setParentCode(target.majorCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                dataSource.put("levelName","第二级");
                model.setDataSource(dataSource);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                systemCodes.add(target.majorCode+"-"+target.systemCode);
            }

            // 判断设备是否存在
            if (!equipmentCodes.contains(target.majorCode+"-"+target.systemCode+"-"+target.equipCode)
                    && StringUtils.isNotBlank(target.equipCode)
                    && StringUtils.isNotBlank(target.equipName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.equipCode);
                model.setName(target.equipName);
                model.setParentCode(target.systemCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode+"-"+target.equipCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                dataSource.put("levelName","第三级");
                model.setDataSource(dataSource);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                equipmentCodes.add(target.majorCode+"-"+target.systemCode+"-"+target.equipCode);
            }
        }
    }

    private void initOccupationalClassification(List<RwdeditRefTypeInfosModel> models, String refKey, String sheetName) throws IOException {
        String file = basepath + "/附表15-枚举值释义表.xlsx";

        FileInputStream inputStream = new FileInputStream(file);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);

        // 行号从0开始, 从第2行开始读数据
        int startRowNum = 2;
        int lastRowNum = sheet.getLastRowNum();
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.majorCode = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 省份编号
            target.majorName = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 省份
            String jobDescription = (String) ExcelUtils.parseCell(row.getCell(3), "string");// 工种描述

            if (null==target.majorCode||null==target.majorName){
                break;
            }

            // 判断专业是否存在
            if (!majorCodes.contains(target.majorCode)
                    && StringUtils.isNotBlank(target.majorCode)
                    && StringUtils.isNotBlank(target.majorName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.majorCode);
                model.setName(target.majorName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.majorCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                if(StringUtils.isNotBlank(jobDescription)){
                    model.setDataSource(objectMapper.createObjectNode().put("jobDescription",jobDescription));
                }
                models.add(model);
                majorCodes.add(target.majorCode);
            }
        }
    }
    private void initContaminatedLevel(List<RwdeditRefTypeInfosModel> models, String refKey, String sheetName) throws IOException {
        String file = basepath + "/附表15-枚举值释义表.xlsx";

        FileInputStream inputStream = new FileInputStream(file);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);

        // 行号从0开始, 从第2行开始读数据
        int startRowNum = 2;
        int lastRowNum = sheet.getLastRowNum();
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.majorCode = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 省份编号
            target.majorName = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 省份
            String contaminatedDescribe = (String) ExcelUtils.parseCell(row.getCell(3), "string");// 说明

            if (null==target.majorCode||null==target.majorName){
                break;
            }

            // 判断专业是否存在
            if (!majorCodes.contains(target.majorCode)
                    && StringUtils.isNotBlank(target.majorCode)
                    && StringUtils.isNotBlank(target.majorName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.majorCode);
                model.setName(target.majorName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.majorCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                if(StringUtils.isNotBlank(contaminatedDescribe)){
                    model.setDataSource(objectMapper.createObjectNode().put("contaminatedDescribe",contaminatedDescribe));
                }
                models.add(model);
                majorCodes.add(target.majorCode);
            }
        }
    }
    private void initFilthLevel(List<RwdeditRefTypeInfosModel> models, String refKey, String sheetName) throws IOException {
        String file = basepath + "/附表15-枚举值释义表.xlsx";

        FileInputStream inputStream = new FileInputStream(file);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);

        // 行号从0开始, 从第2行开始读数据
        int startRowNum = 2;
        int lastRowNum = sheet.getLastRowNum();
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.majorCode = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 省份编号
            target.majorName = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 省份
            String filthDescribe = (String) ExcelUtils.parseCell(row.getCell(3), "string");// 说明

            if (null==target.majorCode||null==target.majorName){
                break;
            }

            // 判断专业是否存在
            if (!majorCodes.contains(target.majorCode)
                    && StringUtils.isNotBlank(target.majorCode)
                    && StringUtils.isNotBlank(target.majorName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.majorCode);
                model.setName(target.majorName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.majorCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                if(StringUtils.isNotBlank(filthDescribe)){
                    model.setDataSource(objectMapper.createObjectNode().put("filthDescribe",filthDescribe));
                }
                models.add(model);
                majorCodes.add(target.majorCode);
            }
        }
    }
    private void initWaterproofLevel(List<RwdeditRefTypeInfosModel> models, String refKey, String sheetName) throws IOException {
        String file = basepath + "/附表15-枚举值释义表.xlsx";

        FileInputStream inputStream = new FileInputStream(file);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);

        // 行号从0开始, 从第2行开始读数据
        int startRowNum = 13;
        int lastRowNum = sheet.getLastRowNum();
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.majorCode = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 省份编号
            target.majorName = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 省份
            String proofDescribe = (String) ExcelUtils.parseCell(row.getCell(3), "string");// 说明

            if (null==target.majorCode||null==target.majorName){
                break;
            }

            // 判断专业是否存在
            if (!majorCodes.contains(target.majorCode)
                    && StringUtils.isNotBlank(target.majorCode)
                    && StringUtils.isNotBlank(target.majorName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.majorCode);
                model.setName(target.majorName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.majorCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                if(StringUtils.isNotBlank(proofDescribe)){
                    model.setDataSource(objectMapper.createObjectNode().put("proofDescribe",proofDescribe));
                }
                models.add(model);
                majorCodes.add(target.majorCode);
            }
        }
    }
    private void initDustproofLevel(List<RwdeditRefTypeInfosModel> models, String refKey, String sheetName) throws IOException {
        String file = basepath + "/附表15-枚举值释义表.xlsx";

        FileInputStream inputStream = new FileInputStream(file);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);

        // 行号从0开始, 从第2行开始读数据
        int startRowNum = 3;
        int lastRowNum = sheet.getLastRowNum();
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.majorCode = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 省份编号
            target.majorName = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 省份
            String proofDescribe = (String) ExcelUtils.parseCell(row.getCell(3), "string");// 说明

            if (null==target.majorCode||null==target.majorName){
                break;
            }

            // 判断专业是否存在
            if (!majorCodes.contains(target.majorCode)
                    && StringUtils.isNotBlank(target.majorCode)
                    && StringUtils.isNotBlank(target.majorName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.majorCode);
                model.setName(target.majorName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.majorCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                if(StringUtils.isNotBlank(proofDescribe)){
                    model.setDataSource(objectMapper.createObjectNode().put("proofDescribe",proofDescribe));
                }
                models.add(model);
                majorCodes.add(target.majorCode);
            }
        }
    }
    private void initSeismicFortificationIntensity(List<RwdeditRefTypeInfosModel> models, String refKey, String sheetName) throws IOException {
        String file = basepath + "/附表15-枚举值释义表.xlsx";

        FileInputStream inputStream = new FileInputStream(file);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);

        // 行号从0开始, 从第2行开始读数据
        int startRowNum = 18;
        int lastRowNum = sheet.getLastRowNum();
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.majorCode = (String) ExcelUtils.parseCell(row.getCell(0), "string");// 省份编号
            target.majorName = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 省份
            target.systemCode = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 序号
            target.systemName = (String) ExcelUtils.parseCell(row.getCell(3), "string");// 抗震设防烈度
            String acceleratedSpeed = (String) ExcelUtils.parseCell(row.getCell(4), "string");// 设计基本地震加速度值(g）
            String groupNum = (String) ExcelUtils.parseCell(row.getCell(5), "string");// 组别
            String correspondingArea = (String) ExcelUtils.parseCell(row.getCell(6), "string");// 对应地区

            // 专业不为空
            if (target.majorCode != null) {
                cache.majorCode = target.majorCode;
                cache.majorName = target.majorName;
                cache.systemCode = null;
                cache.systemName = null;
                cache.equipCode = null;
                cache.equipName = null;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.majorCode = cache.majorCode;
                target.majorName = cache.majorName;
            }
            // 系统不为空
            if (target.systemCode != null) {}

            // 判断专业是否存在
            if (!majorCodes.contains(target.majorCode)
                    && StringUtils.isNotBlank(target.majorCode)
                    && StringUtils.isNotBlank(target.majorName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.majorCode);
                model.setName(target.majorName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.majorCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.systemCode)){
                    if(StringUtils.isNotBlank(acceleratedSpeed)){
                        dataSource.put("acceleratedSpeed",acceleratedSpeed);
                    }
                    if(StringUtils.isNotBlank(groupNum)){
                        dataSource.put("groupNum",groupNum);
                    }
                    if(StringUtils.isNotBlank(correspondingArea)){
                        dataSource.put("correspondingArea",correspondingArea);
                    }
                }
                model.setDataSource(dataSource);
                models.add(model);
                majorCodes.add(target.majorCode);
            }

            // 判断系统是否存在
            if (!systemCodes.contains(target.majorCode+"-"+target.systemCode)
                    && StringUtils.isNotBlank(target.systemCode)
                    && StringUtils.isNotBlank(target.systemName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.majorCode+target.systemCode);
                model.setName(target.systemName);
                model.setParentCode(target.majorCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if(StringUtils.isNotBlank(acceleratedSpeed)){
                    dataSource.put("acceleratedSpeed",acceleratedSpeed);
                }
                if(StringUtils.isNotBlank(groupNum)){
                    dataSource.put("groupNum",groupNum);
                }
                if(StringUtils.isNotBlank(correspondingArea)){
                    dataSource.put("correspondingArea",correspondingArea);
                }
                model.setDataSource(dataSource);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                systemCodes.add(target.majorCode+"-"+target.systemCode);
            }
        }
    }

    private void initDirectionCode(List<RwdeditRefTypeInfosModel> models, String refKey, String sheetName) throws IOException {
        String file = basepath + "/附表15-枚举值释义表.xlsx";

        FileInputStream inputStream = new FileInputStream(file);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);

        // 行号从0开始, 从第2行开始读数据
        int startRowNum = 2;
        int lastRowNum = sheet.getLastRowNum();
        Set<String> systemCodes = new HashSet<>();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            String code = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 编码
            String name = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 名称
            String directionCode = (String) ExcelUtils.parseCell(row.getCell(3), "string");// 方向
            String directionAngle = (String) ExcelUtils.parseCell(row.getCell(4), "string");// 与正北方向顺时针夹角
            if (StringUtils.isBlank(code) || StringUtils.isBlank(name)){
                continue;
            }
            if (!code.matches("^[0-9a-zA-Z-]$") || systemCodes.contains(code)){
                continue;
            }
            RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
            model.setRefKey(refKey);
            model.setCode(code);
            model.setName(name);
            ObjectNode dataSource = objectMapper.createObjectNode();
            if (StringUtils.isNotBlank(directionCode)){
                dataSource.put("directionCode",directionCode);
            }
            if (StringUtils.isNotBlank(directionAngle)){
                dataSource.put("directionAngle",directionAngle);
            }
            if (dataSource.size()>0){
                model.setDataSource(dataSource);
            }
            model.setParentCode("-9999");
            model.setCodePath(refKey+"-"+code);
            model.setCreateUser(CREATE_USER_ID);
            model.setUpdateUser(UPDATE_USER_ID);
            models.add(model);
            systemCodes.add(code);
        }
    }

    private void initAirWindRating(List<RwdeditRefTypeInfosModel> models, String refKey, String sheetName) throws IOException {
        String file = basepath + "/附表15-枚举值释义表.xlsx";

        FileInputStream inputStream = new FileInputStream(file);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);

        // 行号从0开始, 从第2行开始读数据
        int startRowNum = 2;
        int lastRowNum = sheet.getLastRowNum();
        Set<String> systemCodes = new HashSet<>();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            String code = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 编码
            String name = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 风级
            String windAlias = (String) ExcelUtils.parseCell(row.getCell(3), "string");// 名称
            String windSpeed = (String) ExcelUtils.parseCell(row.getCell(4), "string");// 风速
            String landSurfaceImage = (String) ExcelUtils.parseCell(row.getCell(5), "string");// 陆地地面物象
            String seaWaves = (String) ExcelUtils.parseCell(row.getCell(6), "string");// 海面波浪
            if (StringUtils.isBlank(code) || StringUtils.isBlank(name)){
                continue;
            }
            if (!code.matches("^[0-9a-zA-Z-]$") || systemCodes.contains(code)){
                continue;
            }
            RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
            model.setRefKey(refKey);
            model.setCode(code);
            model.setName(name);
            ObjectNode dataSource = objectMapper.createObjectNode();
            if (StringUtils.isNotBlank(windAlias)){
                dataSource.put("windAlias",windAlias);
            }
            if (StringUtils.isNotBlank(windSpeed)){
                dataSource.put("windSpeed",windSpeed);
            }
            if (StringUtils.isNotBlank(landSurfaceImage)){
                dataSource.put("landSurfaceImage",landSurfaceImage);
            }
            if (StringUtils.isNotBlank(seaWaves)){
                dataSource.put("seaWaves",seaWaves);
            }
            if (dataSource.size()>0){
                model.setDataSource(dataSource);
            }
            model.setParentCode("-9999");
            model.setCodePath(refKey+"-"+code);
            model.setCreateUser(CREATE_USER_ID);
            model.setUpdateUser(UPDATE_USER_ID);
            models.add(model);
            systemCodes.add(code);
        }
    }
    private void initWeatherConditions(List<RwdeditRefTypeInfosModel> models, String refKey, String sheetName) throws IOException {
        String file = basepath + "/附表15-枚举值释义表.xlsx";

        FileInputStream inputStream = new FileInputStream(file);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);

        // 行号从0开始, 从第2行开始读数据
        int startRowNum = 2;
        int lastRowNum = sheet.getLastRowNum();
        Set<String> systemCodes = new HashSet<>();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            String weatherCode = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 一级名称
            String weatherName = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 一级编码
            String picFlag = (String) ExcelUtils.parseCell(row.getCell(3), "string");//二级名称
            if (StringUtils.isBlank(weatherCode) || StringUtils.isBlank(weatherName)){
                continue;
            }
            if (!weatherCode.matches("^[0-9a-zA-Z-]$") || systemCodes.contains(weatherCode)){
                continue;
            }
            RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
            model.setRefKey(refKey);
            model.setCode(weatherCode);
            model.setName(weatherName);
            if (StringUtils.isNotBlank(picFlag)){
                model.setDataSource(objectMapper.createObjectNode().put("picFlag",picFlag));
            }
            model.setParentCode("-9999");
            model.setCodePath(refKey+"-"+weatherCode);
            model.setCreateUser(CREATE_USER_ID);
            model.setUpdateUser(UPDATE_USER_ID);
            models.add(model);
            systemCodes.add(weatherCode);
        }
    }

    private void initCityDevelopmentLevel(List<RwdeditRefTypeInfosModel> models, String refKey, String sheetName) throws IOException {
        String file = basepath + "/附表14-地域性信息表.xlsx";

        FileInputStream inputStream = new FileInputStream(file);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);

        // 行号从0开始, 从第2行开始读数据
        int startRowNum = 3;
        int lastRowNum = sheet.getLastRowNum();
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        Set<String> equipCodes = new HashSet<>();
        Set<String> componentCodes = new HashSet<>();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.majorName = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 一级名称
            target.majorCode = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 一级编码
            target.systemName = (String) ExcelUtils.parseCell(row.getCell(3), "string");//二级名称
            target.systemCode = (String) ExcelUtils.parseCell(row.getCell(4), "string");//二级编码
            target.equipName = (String) ExcelUtils.parseCell(row.getCell(5), "string");//三级名称
            target.equipCode = (String) ExcelUtils.parseCell(row.getCell(6), "string");//三级编码
            target.componentName = (String) ExcelUtils.parseCell(row.getCell(7), "string");//二级名称
            target.componentCode = (String) ExcelUtils.parseCell(row.getCell(8), "string");//二级编码
            String commentsOnForm = (String) ExcelUtils.parseCell(row.getCell(9), "string");//备注

            // 专业不为空
            if (target.majorCode != null) {
                cache.majorCode = target.majorCode;
                cache.majorName = target.majorName;
                cache.systemCode = null;
                cache.systemName = null;
                cache.equipCode = null;
                cache.equipName = null;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.majorCode = cache.majorCode;
                target.majorName = cache.majorName;
            }
            // 系统不为空
            if (target.systemCode != null) {
                cache.systemCode = target.systemCode;
                cache.systemName = target.systemName;
                cache.equipCode = null;
                cache.equipName = null;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.systemCode = cache.systemCode;
                target.systemName = cache.systemName;
            }
            // 三级不为空
            if (target.equipCode != null) {
                cache.equipCode = target.equipCode;
                cache.equipName = target.equipName;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.equipCode = cache.equipCode;
                target.equipName = cache.equipName;
            }
            // 四级
            if (target.componentCode != null) {}

            // 判断专业是否存在
            if (!majorCodes.contains(target.majorCode)
                    && StringUtils.isNotBlank(target.majorCode)
                    && StringUtils.isNotBlank(target.majorName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.majorCode);
                model.setName(target.majorName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.majorCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.systemCode)
                        && StringUtils.isBlank(target.equipCode)
                        && StringUtils.isBlank(target.componentCode)
                        && StringUtils.isNotBlank(commentsOnForm)){
                    dataSource.put("commentsOnForm",commentsOnForm);
                }
                dataSource.put("levelName","第一级");
                model.setDataSource(dataSource);
                models.add(model);
                majorCodes.add(target.majorCode);
            }

            // 判断系统是否存在
            if (!systemCodes.contains(target.systemCode)
                    && StringUtils.isNotBlank(target.systemCode)
                    && StringUtils.isNotBlank(target.systemName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.systemCode);
                model.setName(target.systemName);
                model.setParentCode(target.majorCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.equipCode)
                        && StringUtils.isBlank(target.componentCode)
                        && StringUtils.isNotBlank(commentsOnForm)){
                    dataSource.put("commentsOnForm",commentsOnForm);
                }
                dataSource.put("levelName","第二级");
                model.setDataSource(dataSource);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                systemCodes.add(target.systemCode);
            }
            // 判断系统是否存在
            if (!equipCodes.contains(target.equipCode)
                    && StringUtils.isNotBlank(target.equipCode)
                    && StringUtils.isNotBlank(target.equipName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.equipCode);
                model.setName(target.equipName);
                model.setParentCode(target.systemCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode+"-"+target.equipCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.componentCode)
                        && StringUtils.isNotBlank(commentsOnForm)){
                    dataSource.put("commentsOnForm",commentsOnForm);
                }
                dataSource.put("levelName","第三级");
                model.setDataSource(dataSource);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                equipCodes.add(target.equipCode);
            }
            // 判断系统是否存在
            if (!componentCodes.contains(target.componentCode)
                    && StringUtils.isNotBlank(target.componentCode)
                    && StringUtils.isNotBlank(target.componentName)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.componentCode);
                model.setName(target.componentName);
                model.setParentCode(target.equipCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode+"-"+target.equipCode+"-"+target.componentCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isNotBlank(commentsOnForm)){
                    dataSource.put("commentsOnForm",commentsOnForm);
                }
                dataSource.put("levelName","第四级");
                model.setDataSource(dataSource);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                componentCodes.add(target.componentCode);
            }
        }


    }

    private void initGeographicalDivision(List<RwdeditRefTypeInfosModel> models, String refKey, String sheetName) throws IOException {
        String file = basepath + "/附表14-地域性信息表.xlsx";

        FileInputStream inputStream = new FileInputStream(file);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);

        // 行号从0开始, 从第2行开始读数据
        int startRowNum = 2;
        int lastRowNum = sheet.getLastRowNum();
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.majorName = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 名称
            target.majorCode = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 编码
            target.systemName = (String) ExcelUtils.parseCell(row.getCell(4), "string");//名称
            target.systemCode = (String) ExcelUtils.parseCell(row.getCell(3), "string");//编码
            String inclusion = (String) ExcelUtils.parseCell(row.getCell(5), "string");//包含

            // 专业不为空
            if (target.majorCode != null) {
                cache.majorCode = target.majorCode;
                cache.majorName = target.majorName;
                cache.systemCode = null;
                cache.systemName = null;
                cache.equipCode = null;
                cache.equipName = null;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.majorCode = cache.majorCode;
                target.majorName = cache.majorName;
            }
            // 系统不为空
            if (target.systemCode != null) {}

            // 判断专业是否存在
            if (!majorCodes.contains(target.majorCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.majorCode);
                model.setName(target.majorName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.majorCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.systemCode) && StringUtils.isNotBlank(inclusion)){
                    dataSource.put("inclusion",inclusion);
                }
                dataSource.put("levelName","第一级");
                model.setDataSource(dataSource);
                models.add(model);
                majorCodes.add(target.majorCode);
            }

            // 判断系统是否存在
            if (!systemCodes.contains(target.systemCode) && StringUtils.isNotBlank(target.systemCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.systemCode);
                model.setName(target.systemName);
                model.setParentCode(target.majorCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isNotBlank(inclusion)){
                    dataSource.put("inclusion",inclusion);
                }
                dataSource.put("levelName","第二级");
                model.setDataSource(dataSource);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                systemCodes.add(target.systemCode);
            }
        }


    }


    private void initFuncidCodeVocabulary(List<RwdeditRefTypeInfosModel> models, String refKey, String sheetName) throws IOException {
        String file = basepath + "/附表4-信息点编码词汇表.xlsx";

        FileInputStream inputStream = new FileInputStream(file);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);

        // 行号从0开始, 从第2行开始读数据
        int startRowNum = 2;
        int lastRowNum = sheet.getLastRowNum();
        Set<String> codes = new HashSet<>();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            String chineseWord = (String) ExcelUtils.parseCell(row.getCell(0), "string");//中文词汇
            String code = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 名称原文
            String name = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 名称缩写
            if (codes.contains(code)){
                log.info("code[{}] is exist", code);
                continue;
            }
            if (StringUtils.isBlank(code) || StringUtils.isBlank(name)){
                log.info("code[{}] or name[{}] is null", code,name);
                continue;
            }
            codes.add(code);
            RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
            model.setRefKey(refKey);
            model.setCode(code);
            model.setName(name);
            model.setParentCode("-9999");
            model.setCodePath(refKey+"-"+code);
            model.setCreateUser(CREATE_USER_ID);
            model.setUpdateUser(UPDATE_USER_ID);
            if (StringUtils.isNotBlank(chineseWord)){
                model.setDataSource(objectMapper.createObjectNode().put("chineseWord",chineseWord));
            }
            models.add(model);
        }


    }

    private void initClimaticDivision(List<RwdeditRefTypeInfosModel> models, String refKey, String sheetName) throws IOException {
        String file = basepath + "/附表14-地域性信息表.xlsx";

        FileInputStream inputStream = new FileInputStream(file);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);

        // 行号从0开始, 从第2行开始读数据
        int startRowNum = 3;
        int lastRowNum = sheet.getLastRowNum();
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        Set<String> equipmentCodes = new HashSet<>();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.majorName = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 名称
            target.majorCode = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 编码
            target.systemName = (String) ExcelUtils.parseCell(row.getCell(3), "string");//名称
            target.systemCode = (String) ExcelUtils.parseCell(row.getCell(4), "string");//编码
            String describe = (String) ExcelUtils.parseCell(row.getCell(5), "string");//分区依据（说明）

            // 专业不为空
            if (target.majorCode != null) {
                cache.majorCode = target.majorCode;
                cache.majorName = target.majorName;
                cache.systemCode = null;
                cache.systemName = null;
                cache.equipCode = null;
                cache.equipName = null;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.majorCode = cache.majorCode;
                target.majorName = cache.majorName;
            }
            // 系统不为空
            if (target.systemCode != null) {}

            // 判断专业是否存在
            if (!majorCodes.contains(target.majorCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.majorCode);
                model.setName(target.majorName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.majorCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isBlank(target.systemCode) && StringUtils.isNotBlank(describe)){
                    dataSource.put("zoningBasis",describe);
                }
                dataSource.put("levelName","第一级");
                model.setDataSource(dataSource);
                models.add(model);
                majorCodes.add(target.majorCode);
            }

            // 判断系统是否存在
            if (!systemCodes.contains(target.systemCode) && StringUtils.isNotBlank(target.systemCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(target.systemCode);
                model.setName(target.systemName);
                model.setParentCode(target.majorCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode);
                ObjectNode dataSource = objectMapper.createObjectNode();
                if (StringUtils.isNotBlank(describe)){
                    dataSource.put("zoningBasis",describe);
                }
                dataSource.put("levelName","第二级");
                model.setDataSource(dataSource);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                systemCodes.add(target.systemCode);
            }
        }


    }


    public void initCityLocation(List<RwdeditRefTypeInfosModel> models, String refKey, String sheetName) throws Exception {
        String file = basepath + "/附表14-地域性信息表.xlsx";

        FileInputStream inputStream = new FileInputStream(file);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);

        // 行号从0开始, 从第2行开始读数据
        int startRowNum = 2;
        int lastRowNum = sheet.getLastRowNum();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            String cityCode = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 市级code
            String areaCode = (String) ExcelUtils.parseCell(row.getCell(4), "string");// 区级code
            String name = (String) ExcelUtils.parseCell(row.getCell(5), "string");// 名称
            Integer codeInt = (Integer)ExcelUtils.parseCell(row.getCell(6), "integer");// code
            if (null==name || null == codeInt){
                continue;
            }
            String code = codeInt.toString();
            Double longitude = (Double) ExcelUtils.parseCell(row.getCell(7), "double");// 精度
            Double latitude = (Double) ExcelUtils.parseCell(row.getCell(8), "double");// 维度
            Double altitude = (Double) ExcelUtils.parseCell(row.getCell(9), "double");// 海拔
            String climaticDivisionCode = (String) ExcelUtils.parseCell(row.getCell(10), "string");// 气候区
            String cityDevelopmentLevelCode = (String) ExcelUtils.parseCell(row.getCell(11), "string");// 发展水平
            RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
            model.setRefKey(refKey);
            model.setCode(code);
            model.setName(name);
            model.setParentCode(cache.equipCode);
            model.setCodePath(refKey+"-"+cache.systemCode+"-"+cache.equipCode+"-"+code);
            if (StringUtils.isNotBlank(climaticDivisionCode)){
                cache.climaticDivisionCode = climaticDivisionCode;
            }
            ObjectNode objectNode = objectMapper.createObjectNode()
                    .put("altitude", altitude)
                    .put("latitude", latitude)
                    .put("longitude", longitude)
                    .put("climaticDivisionCode", cache.climaticDivisionCode)
                    .put("cityDevelopmentLevelCode", cityDevelopmentLevelCode);
            objectNode.put("levelName","第三级");
            if ("00".equals(cityCode) && "00".equals(areaCode)){
                // 省
                cache.systemCode = code;
                cache.systemName = name;
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+code);
                objectNode.put("levelName","第一级");
            }
            if (!"00".equals(cityCode) && "00".equals(areaCode)){
                // 市
                cache.equipCode = code;
                cache.equipName = name;
                model.setParentCode(cache.systemCode);
                model.setCodePath(refKey+"-"+cache.systemCode+"-"+code);
                objectNode.put("levelName","第二级");
            }
            model.setDataSource(objectNode);
            model.setCreateUser(CREATE_USER_ID);
            model.setUpdateUser(UPDATE_USER_ID);
            models.add(model);
        }
    }

    private void writeFuncSqlToFile(List<RwdeditRefTypeInfosModel> classes,String refKey) throws IOException {
        FileWriter writer = new FileWriter(outPath,true);
        for (int i = 0; i < classes.size(); i++) {
            classes.get(i).setSeq(i+1);
        }
        writer.append("delete from rwdedit_ref_type_infos where ref_key='"+refKey+"';");
        writer.append("\n");
        writer.append("commit;");
        writer.append("\n");
        for (RwdeditRefTypeInfosModel item : classes) {
            writer.append(toSql(item));
            writer.append("\n");
        }
        writer.append("commit;");
        writer.append("\n");
        writer.flush();
        writer.close();
        System.out.println("[");
        JacksonCriteria jacksonCriteria = JacksonCriteria.newInstance();
        for (RwdeditRefTypeInfosModel type : classes) {
            ObjectNode criteria = jacksonCriteria.getCriteria();
            criteria.put("code",type.getCode());
            criteria.put("name",type.getName().trim());
            criteria.put("parentCode",type.getParentCode());
            System.out.println(JacksonMapper.toSimpleJson(criteria)+",");
        }
        System.out.println("]");
    }

    private String toSql(RwdeditRefTypeInfosModel model) {
        StringBuilder sb = new StringBuilder();
        sb.append("INSERT INTO `rwdedit_ref_type_infos`(`ref_key`, `code`, `name`,`code_path`, `parent_code`, `data_source`, `create_user`, `update_user`, `seq`) VALUES ( ");
        sb.append("'").append(model.getRefKey()).append("', ");
        sb.append("'").append(model.getCode()).append("', ");
        sb.append("'").append(model.getName()).append("', ");
        sb.append("'").append(model.getCodePath()).append("', ");
        sb.append("'").append(model.getParentCode()).append("', ");
        if (null!=model.getDataSource()){
            sb.append("'").append(JacksonMapper.toSimpleJson(model.getDataSource())).append("', ");
        }else {
            sb.append("null, ");
        }
        sb.append(model.getCreateUser()).append(", ");
        sb.append(model.getUpdateUser()).append(", ");
        sb.append(model.getSeq()).append(");");
        return sb.toString();
    }

    private void initEquipment(List<RwdeditRefTypeInfosModel> models,String refKey) throws IOException {
        String classFile = basepath + "/附表1-机电精装类对象分类体系.xlsx";
        String sheetName = "系统设备部件类";
        FileInputStream inputStream = new FileInputStream(classFile);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);
        if (sheet == null) {
            return;
        }

        // 行号从0开始, 从第2行开始读数据
        Set<String> systemCodes = new HashSet<>();
        Set<String> majorCodes = new HashSet<>();
        Set<String> equipmentCodes = new HashSet<>();
        int startRowNum = 2;
        int lastRowNum = sheet.getLastRowNum();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.majorCode = (String) ExcelUtils.parseCell(row.getCell(0), "string");// 专业编码
            target.majorEnglishName = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 专业英文名称
            target.majorName = (String) ExcelUtils.parseCell(row.getCell(2), "string");// 专业名称
            target.systemCode = (String) ExcelUtils.parseCell(row.getCell(3), "string");//系统类编码
            target.systemEnglishName = (String) ExcelUtils.parseCell(row.getCell(4), "string");//系统类英文名称
            target.systemName = (String) ExcelUtils.parseCell(row.getCell(5), "string");//系统类名称
            target.equipCode = (String) ExcelUtils.parseCell(row.getCell(6), "string");//设备设施类编码
            target.equipEnglishName = (String) ExcelUtils.parseCell(row.getCell(7), "string");//设备设施类英文名称
            target.equipName = (String) ExcelUtils.parseCell(row.getCell(8), "string");//设备设施类名称
            target.componentCode = (String) ExcelUtils.parseCell(row.getCell(9), "string");//部件类编码
            target.componentEnglishName = (String) ExcelUtils.parseCell(row.getCell(10), "string");//部件类英文名称
            target.componentName = (String) ExcelUtils.parseCell(row.getCell(11), "string");//部件类名称
//			System.out.println(rowIndex + ": " + target.majorCode + "\t" + target.systemCode + "\t" + target.equipCode + "\t" + target.componentCode);

            // 专业不为空
            if (target.majorCode != null) {
                cache.majorCode = target.majorCode;
                cache.majorName = target.majorName;
                cache.majorEnglishName = target.majorEnglishName;
                cache.systemCode = null;
                cache.systemName = null;
                cache.equipCode = null;
                cache.equipName = null;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.majorCode = cache.majorCode;
                target.majorName = cache.majorName;
                target.majorEnglishName = cache.majorEnglishName;
            }
            // 系统不为空
            if (target.systemCode != null) {
                cache.systemCode = target.systemCode;
                cache.systemEnglishName = target.systemEnglishName;
                cache.systemName = target.systemName;
                cache.equipCode = null;
                cache.equipEnglishName = null;
                cache.equipName = null;
                cache.componentCode = null;
                cache.componentEnglishName = null;
                cache.componentName = null;
            } else {
                target.systemCode = cache.systemCode;
                target.systemEnglishName = cache.systemEnglishName;
                target.systemName = cache.systemName;
            }
            // 设备不为空
            if (target.equipCode != null) {
                cache.equipCode = target.equipCode;
                cache.equipEnglishName = target.equipEnglishName;
                cache.equipName = target.equipName;
                cache.componentCode = null;
                cache.componentEnglishName = null;
                cache.componentName = null;
            } else {
                target.equipCode = cache.equipCode;
                target.equipEnglishName = cache.equipEnglishName;
                target.equipName = cache.equipName;
            }
            // 部件不为空
            if (target.componentCode != null) {
            }

            // 拼装实际的系统编码和设备编码
            CacheModel object = new CacheModel();
            object.majorCode = target.majorCode;
            object.majorName = target.majorName;
            object.majorEnglishName = target.majorEnglishName;
            object.systemCode = target.majorCode + target.systemCode;
            object.systemName = target.systemName;
            object.systemEnglishName = target.systemEnglishName;
            object.equipCode = target.majorCode + target.equipCode;
            object.equipName = target.equipName;
            object.equipEnglishName = target.equipEnglishName;
            object.componentCode = StrUtil.isBlankIfStr(target.componentCode)?"":target.majorCode + target.componentCode;
            object.componentName = target.componentName;
            object.componentEnglishName = target.componentEnglishName;

            // 判断专业是否存在
            if (StrUtil.isNotBlank(object.majorCode)
                    && StrUtil.isNotBlank(object.majorName)
                    && !majorCodes.contains(object.majorCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(object.majorCode);
                model.setName(object.majorName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.majorCode);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode().put("englishName", object.majorEnglishName);
                dataSource.put("levelName","专业");
                model.setDataSource(dataSource);
                models.add(model);
                majorCodes.add(object.majorCode);
            }

            // 判断系统是否存在
            if (StrUtil.isNotBlank(object.systemCode)
                    && StrUtil.isNotBlank(object.systemName)
                    && !systemCodes.contains(object.systemCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(object.systemCode);
                model.setName(object.systemName);
                model.setParentCode(object.majorCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode);
                ObjectNode dataSource = objectMapper.createObjectNode().put("englishName", object.systemEnglishName);
                dataSource.put("levelName","系统");
                model.setDataSource(dataSource);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                systemCodes.add(object.systemCode);
            }

            // 判断设备是否存在
            if (StrUtil.isNotBlank(object.equipCode)
                    && StrUtil.isNotBlank(object.equipName)
                    && !equipmentCodes.contains(object.equipCode)) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(object.equipCode);
                model.setName(object.equipName);
                model.setParentCode(object.systemCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode+"-"+target.equipCode);
                ObjectNode dataSource = objectMapper.createObjectNode().put("englishName", object.equipEnglishName);
                dataSource.put("levelName","设备");
                model.setDataSource(dataSource);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
                equipmentCodes.add(object.equipCode);
            }
            // 部件不为空
            if (StrUtil.isNotBlank(object.componentCode)
                    && StrUtil.isNotBlank(object.componentName)
                    && object.componentCode != null) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(object.componentCode);
                model.setName(object.componentName);
                model.setParentCode(object.equipCode);
                model.setCodePath(refKey+"-"+target.majorCode+"-"+target.systemCode+"-"+target.equipCode+"-"+target.componentCode);
                ObjectNode dataSource = objectMapper.createObjectNode().put("englishName", object.componentEnglishName);
                dataSource.put("levelName","部件");
                model.setDataSource(dataSource);
                model.setCreateUser(CREATE_USER_ID);
                model.setUpdateUser(UPDATE_USER_ID);
                models.add(model);
            }
        }
    }

    private void initToolOrMaterial(List<RwdeditRefTypeInfosModel> classes,String refKey,String sheetName) throws IOException {
        String classFile = basepath + "/附表2-耗材工具类对象分类体系.xlsx";
        FileInputStream inputStream = new FileInputStream(classFile);
        Workbook workbook = new XSSFWorkbook(inputStream);
        Sheet sheet = workbook.getSheet(sheetName);
        if (sheet == null) {
            return;
        }

        Set<String> systemCodes = new HashSet<>();
        Set<String> equipCodes = new HashSet<>();

        // 行号从0开始, 从第2行开始读数据
        // 一级分类使用systemCode, 二级分类使用equipCode
        int startRowNum = 1;
        int lastRowNum = sheet.getLastRowNum();
        CacheModel cache = new CacheModel();
        for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                log.info("row[{}] is null", rowIndex);
                continue;
            }
            // 0专业, 3系统编码, 5系统名称, 6设备编码, 8设备名称
            CacheModel target = new CacheModel();
            target.systemCode = (String) ExcelUtils.parseCell(row.getCell(0), "string");// 一级分类编码
            target.systemEnglishName = (String) ExcelUtils.parseCell(row.getCell(1), "string");// 一级分类英文名称
            target.systemName = (String) ExcelUtils.parseCell(row.getCell(2), "string");//一级分类名称
            target.equipCode = (String) ExcelUtils.parseCell(row.getCell(3), "string");//二级分类编码
            target.equipEnglishName = (String) ExcelUtils.parseCell(row.getCell(4), "string");//二级分类英文名称
            target.equipName = (String) ExcelUtils.parseCell(row.getCell(5), "string");//二级分类名称
            target.componentCode = (String) ExcelUtils.parseCell(row.getCell(6), "string");//工具类编码
            target.componentEnglishName = (String) ExcelUtils.parseCell(row.getCell(7), "string");//工具类英文名称
            target.componentName = (String) ExcelUtils.parseCell(row.getCell(8), "string");//工具类名称
//			System.out.println(rowIndex + ": " + target.majorCode + "\t" + target.systemCode + "\t" + target.equipCode + "\t" + target.componentCode);

            // 一级分类编码
            if (target.systemCode != null) {
                cache.systemCode = target.systemCode;
                cache.systemName = target.systemName;
                cache.systemEnglishName = target.systemEnglishName;
                cache.equipCode = null;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.systemCode = cache.systemCode;
                target.systemName = cache.systemName;
                target.systemEnglishName = cache.systemEnglishName;
            }
            // 二级分类编码
            if (target.equipCode != null) {
                cache.equipCode = target.equipCode;
                cache.equipName = target.equipName;
                cache.equipEnglishName = target.equipEnglishName;
                cache.componentCode = null;
                cache.componentName = null;
            } else {
                target.equipCode = cache.equipCode;
                target.equipName = cache.equipName;
                target.equipEnglishName = cache.equipEnglishName;
            }

            // 拼装实际的系统编码和设备编码
            CacheModel object = new CacheModel();
            object.systemCode = target.systemCode;
            object.systemName = target.systemName;
            object.systemEnglishName = target.systemEnglishName;
            object.equipCode = target.systemCode + target.equipCode;
            object.equipName = target.equipName;
            object.equipEnglishName = target.equipEnglishName;
            object.componentCode = target.componentCode;
            object.componentName = target.componentName;
            object.componentEnglishName = target.componentEnglishName;

            // 一级标签
            if (object.systemCode != null && !systemCodes.contains(object.systemCode)) {
                systemCodes.add(object.systemCode);
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(object.systemCode);
                model.setName(object.systemName);
                model.setParentCode("-9999");
                model.setCodePath(refKey+"-"+target.systemCode);
                model.setUpdateUser(UPDATE_USER_ID);
                model.setCreateUser(CREATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode().put("englishName", object.systemEnglishName);
                dataSource.put("levelName","第一级");
                model.setDataSource(dataSource);
                classes.add(model);
            }

            // 二级标签
            if (target.equipCode != null && !equipCodes.contains(object.equipCode)) {
                equipCodes.add(object.equipCode);
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(object.equipCode);
                model.setName(object.equipName);
                model.setParentCode(object.systemCode);
                model.setCodePath(refKey+"-"+target.systemCode+"-"+target.equipCode);
                model.setUpdateUser(UPDATE_USER_ID);
                model.setCreateUser(CREATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode().put("englishName", object.equipEnglishName);
                dataSource.put("levelName","第二级");
                model.setDataSource(dataSource);
                classes.add(model);
            }

            // 工具类编码
            if (object.componentCode != null) {
                RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
                model.setRefKey(refKey);
                model.setCode(object.componentCode);
                model.setName(object.componentName);
                model.setParentCode(object.equipCode);
                model.setCodePath(refKey+"-"+target.systemCode+"-"+target.equipCode+"-"+target.componentCode);
                model.setUpdateUser(UPDATE_USER_ID);
                model.setCreateUser(CREATE_USER_ID);
                ObjectNode dataSource = objectMapper.createObjectNode().put("englishName", object.componentEnglishName);
                dataSource.put("levelName","第三级");
                model.setDataSource(dataSource);
                classes.add(model);
            }
        }
    }

    public static final class CacheModel {
        String majorCode;
        String majorEnglishName;
        String majorName;
        String systemCode;
        String systemEnglishName;
        String systemName;
        String equipCode;
        String equipEnglishName;
        String equipName;
        String componentCode;
        String componentName;
        String componentEnglishName;
        String climaticDivisionCode;
        String extendName;
        String firstLevelCode;
        String firstLevelName;
        String secondLevelCode;
        String secondLevelName;
        String thirdLevelCode;
        String thirdLevelName;
        String fourthLevelCode;
        String fourthLevelName;
        String fifthLevelCode;
        String fifthLevelName;
        String sixthLevelCode;
        String sixthLevelName;
        String seventhLevelCode;
        String seventhLevelName;
    }

    private ClassDefModel prepareModel(String objType, String code, String name, String parentCode, String majorCode, String systemCode) {
        ClassDefModel model = new ClassDefModel();
        model.setObjType(ObjType.valueOf(objType));
        model.setCode(code);
        model.setName(name);
        model.setAliasCode(code);
        model.setAliasName(name);
        model.setParentCode(parentCode);
        model.setMajorCode(majorCode);
        model.setSystemCode(systemCode);
        return model;
    }

}
