package com.persagy.dmp.rwd.edit.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.rwd.edit.entity.AdminUser;
import com.persagy.dmp.rwd.edit.service.AdminUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

@RestController
@RequestMapping("/rwdedit/system/user")
public class AdminUserController {
    @Autowired
    private AdminUserService service;

    @PostMapping("/query")
    public PagedResponse<AdminUser> query(@RequestBody JacksonCriteria criteria) {
        return service.query(criteria);
    }

    @PostMapping("/create")
    public MapResponse create(@RequestBody AdminUser param) {
        return service.create(param);
    }

    @PostMapping("/update")
    public MapResponse update(@RequestBody AdminUser param) {
        return service.update(param);
    }

    @PostMapping("/delete")
    public MapResponse delete(@RequestBody AdminUser param) {
        return service.delete(param);
    }

    @PostMapping(value = "/chgpwd")
    public MapResponse chgpwd(@RequestBody Map<String, String> param) {
        return service.chgpwd(param);
    }

}
