package com.persagy.dmp.rwd.edit.controller;

import com.persagy.dmp.rwd.edit.service.DownloadService;
import lombok.extern.slf4j.Slf4j;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.URLEncoder;

@Slf4j
@RestController
@RequestMapping("/rwdedit/common")
public class DownloadController {

    public final Logger logger = LoggerFactory.getLogger(DownloadController.class);

    @Autowired
    private DownloadService downloadService;

//    @GetMapping("/download")
//    private void download(@RequestParam String type, HttpServletResponse response) {
//        DownloadModel result = downloadService.download(type);
//        if ("workbook".equalsIgnoreCase(result.getType())) {
//            String fileName = result.getName();
//            downloadWorkbook(response, fileName, result.getWorkbook());
//        }
//    }

    @GetMapping("/download")
    private void download(@RequestParam String type, HttpServletRequest req, HttpServletResponse resp) throws Exception{
        //读取文件
        InputStream resourceAsStream = Thread.currentThread().getContextClassLoader().getResourceAsStream("static/file/批量上传变更记录模板.xlsx");
        String fileName = "批量上传变更记录模板.xlsx";
        InputStream inputStream = new BufferedInputStream(resourceAsStream);
        Workbook workbook = new XSSFWorkbook(inputStream);
        downloadService.fillFuncIndexDataToWorkbook(workbook);

        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        workbook.write(bos);
        byte[] brray = bos.toByteArray();
        inputStream = new ByteArrayInputStream(brray);

        OutputStream out = null;
        try {
            String resultFileName = URLEncoder.encode(fileName, "UTF-8");
            resp.reset();// 清空输出流
            resp.setCharacterEncoding("UTF-8");
            resp.setHeader("Content-disposition", "attachment; filename=" + resultFileName);
            resp.setHeader("Connection", "close");
            resp.setHeader("Content-Type", "application/octet-stream");
            out = resp.getOutputStream();
            int len;
            byte[] buffer = new byte[1024];
            while ((len = inputStream.read(buffer)) != -1) {
                out.write(buffer, 0, len);
            }
            out.flush();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (out != null) {
                    out.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    private void downloadWorkbook(HttpServletResponse resp, String fileName, Workbook workbook) {
        OutputStream out = null;
        try {
            resp.reset();// 清空输出流
            String resultFileName = URLEncoder.encode(fileName, "UTF-8");
            resp.setCharacterEncoding("UTF-8");
            resp.setHeader("Content-disposition", "attachment; filename=" + resultFileName);// 设定输出文件头
            resp.setContentType("application/vnd.ms-excel; charset=utf-8");// 定义输出类型
            out = resp.getOutputStream();
            workbook.write(out);
            out.flush();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (out != null) {
                    out.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
