package com.persagy.dmp.rwd.edit.entity;

import com.persagy.dmp.rwd.enums.ObjType;
import com.persagy.dmp.rwd.model.ClassDefModel;
import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.Where;

import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@Table(name = "rwd_def_class")
@Where(clause = "is_used = 1")
@IdClass(GroupPK.class)
public class ClassDef {

    @Id
    private String id;
    @Id
    private String groupCode;
    private String code;
    @Enumerated(value = EnumType.STRING)
    private ObjType objType;
    private String name;
    private String aliasCode;
    private String aliasName;
    private String type;
    private String projectId;
    private String majorCode;
    private String systemCode;
    private String equipmentCode;
    private String parentCode;
    private  Integer orderSeq;
    private Integer isUsed;//使用状态 0.历史版本 1.使用中
    private String version;//版本
    private Date lastUpdateTime;//最后更新时间

    public static ClassDef fromModel(ClassDefModel model) {
        ClassDef entity = new ClassDef();
        entity.setId(model.getId());
        entity.setCode(model.getCode());
        entity.setObjType(model.getObjType());
        entity.setName(model.getName());
        entity.setAliasCode(model.getAliasCode());
        entity.setAliasName(model.getAliasName());
        entity.setType(model.getType());
        entity.setGroupCode(model.getGroupCode());
        entity.setProjectId(model.getProjectId());
        entity.setMajorCode(model.getMajorCode());
        entity.setSystemCode(model.getSystemCode());
        entity.setEquipmentCode(model.getEquipmentCode());
        entity.setParentCode(model.getParentCode());
        entity.setOrderSeq(model.getOrderSeq());
        entity.setIsUsed(model.getIsUsed());//状态 0.历史版本 1.使用中
        entity.setVersion(model.getVersion());//版本
        entity.setLastUpdateTime(model.getLastUpdateTime());//发布时间
        return entity;
    }

    public ClassDefModel toModel() {
        ClassDefModel model = new ClassDefModel();
        model.setId(this.getId());
        model.setCode(this.getCode());
        model.setObjType(this.getObjType());
        model.setName(this.getName());
        model.setAliasCode(this.getAliasCode());
        model.setAliasName(this.getAliasName());
        model.setType(this.getType());
        model.setGroupCode(this.getGroupCode());
        model.setProjectId(this.getProjectId());
        model.setMajorCode(this.getMajorCode());
        model.setSystemCode(this.getSystemCode());
        model.setEquipmentCode(this.getEquipmentCode());
        model.setParentCode(this.getParentCode());
        model.setOrderSeq(this.getOrderSeq());
        model.setIsUsed(this.getIsUsed());//状态 0.历史版本 1.使用中
        model.setVersion(this.getVersion());//版本
        model.setLastUpdateTime(this.getLastUpdateTime());//发布时间
        return model;
    }

}
